//==============================
//	win_ent.c
//==============================

#include "qe3.h"


#define DLGBORDER_X		5
#define DLGBORDER_Y		5

int g_nEntDlgIds[ENT_LAST] = 
{
	IDC_E_LIST,
	IDC_E_COMMENT,
	IDC_E_FLAG1,
	IDC_E_FLAG2,
	IDC_E_FLAG3,
	IDC_E_FLAG4,
	IDC_E_FLAG5,
	IDC_E_FLAG6,
	IDC_E_FLAG7,
	IDC_E_FLAG8,
	IDC_E_FLAG9,
	IDC_E_FLAG10,
	IDC_E_FLAG11,
	IDC_E_FLAG12,
	IDC_E_PROPS,
	IDC_E_0,
	IDC_E_45,
	IDC_E_90,
	IDC_E_135,
	IDC_E_180,
	IDC_E_225,
	IDC_E_270,
	IDC_E_315,
	IDC_E_UP,
	IDC_E_DOWN,
	IDC_E_ADDPROP,	// sikk - Entity Window Addition
	IDC_E_DELPROP,
	IDC_E_CREATE,	// sikk - Entity Window Addition

	IDC_STATIC_KEY,
	IDC_E_KEY_FIELD,
	IDC_STATIC_VALUE,
	IDC_E_VALUE_FIELD,

	IDC_E_COLOR
};

HWND		g_hwndEnt[ENT_LAST];
bool		g_bMultipleEntities;
entity_t   *g_peEditEntity;

/*
=========================
FieldWndProc

Just to handle tab and enter...
=========================
*/
BOOL CALLBACK FieldWndProc (
    HWND	hWnd,	// handle to window
    UINT	uMsg,	// message
    WPARAM	wParam,	// first message parameter
    LPARAM	lParam 	// second message parameter
	)
{
    switch (uMsg)
    {
	case WM_CHAR:
		if (LOWORD(wParam) == VK_TAB)
			return FALSE;
		if (LOWORD(wParam) == VK_RETURN)
			return FALSE;
		if (LOWORD(wParam) == VK_ESCAPE)
		{
			SetFocus(g_qeglobals.d_hwndCamera);
			return FALSE;
		}
		break;

	case WM_KEYDOWN:
		if (LOWORD(wParam) == VK_TAB)
		{
			if (hWnd == g_hwndEnt[ENT_KEYFIELD])
			{
				SendMessage(g_hwndEnt[ENT_VALUEFIELD], WM_SETTEXT, 0, (long)"");
				SetFocus(g_hwndEnt[ENT_VALUEFIELD]);
			}
			else
				SetFocus(g_hwndEnt[ENT_KEYFIELD]);
		}
		if (LOWORD(wParam) == VK_RETURN)
		{
			if (hWnd == g_hwndEnt[ENT_KEYFIELD])
			{
				SendMessage(g_hwndEnt[ENT_VALUEFIELD], WM_SETTEXT, 0, (long)"");
				SetFocus(g_hwndEnt[ENT_VALUEFIELD]);
			}
			else
			{
				AddProp();
//				SetFocus(g_qeglobals.d_hwndCamera);
				SetFocus(g_hwndEnt[ENT_PROPS]);	// sikk - Made sense to keep focus 
			}
		}
		break;

//	case WM_NCHITTEST:

	case WM_LBUTTONDOWN:
// sikk---> LMB Bring to Top
		if (GetTopWindow(g_qeglobals.d_hwndMain) != g_qeglobals.d_hwndEntity)
			BringWindowToTop(g_qeglobals.d_hwndEntity);
// <---sikk
		SetFocus(hWnd);
		break;
	}
	return CallWindowProc(OldFieldWindowProc, hWnd, uMsg, wParam, lParam);
}

/*
=========================
EntityListWndProc

Just to handle enter...
=========================
*/
BOOL CALLBACK EntityListWndProc (
    HWND	hWnd,	// handle to window
    UINT	uMsg,	// message
    WPARAM	wParam,	// first message parameter
    LPARAM	lParam 	// second message parameter
	)
{
    switch (uMsg)
    {
	case WM_KEYDOWN:
		if (LOWORD(wParam) == VK_RETURN)
		{
			SendMessage(g_qeglobals.d_hwndEntity, WM_COMMAND, (LBN_DBLCLK << 16) + IDC_E_LIST, 0);
			return 0;
		}
		break;

// sikk---> LMB Bring to Top
	case WM_LBUTTONDOWN:
		if (GetTopWindow(g_qeglobals.d_hwndMain) != g_qeglobals.d_hwndEntity)
			BringWindowToTop(g_qeglobals.d_hwndEntity);
		break;
// <---sikk
	}
	return CallWindowProc(OldEntityListWindowProc, hWnd, uMsg, wParam, lParam);
}

/*
================
GetEntityControls

Finds the controls from the dialog and
moves them to the window
================
*/
void GetEntityControls (HWND h)
{
	int i;

	for (i = 0; i < ENT_LAST; i++)
	{
		if (i == ENT_LIST || i == ENT_PROPS || i == ENT_COMMENT)
			continue;
		if (i == ENT_KEYFIELD || i == ENT_VALUEFIELD)
			continue;
		g_hwndEnt[i] = GetDlgItem(h, g_nEntDlgIds[i]);		
		if (g_hwndEnt[i])
		{
			SetParent(g_hwndEnt[i], g_qeglobals.d_hwndEntity);
			SendMessage(g_hwndEnt[i], WM_SETFONT, (WPARAM)GetStockObject(DEFAULT_GUI_FONT), (LPARAM)TRUE);
		}
	}

	LoadLibraryA("RICHED32.DLL") ;	// sikk - For Enhanced Editing	

	// SetParent apears to not modify some internal state
	// on listboxes, so create it from scratch...

// sikk---> Misc aesthetic changes
	g_hwndEnt[ENT_LIST] = CreateWindowEx(WS_EX_CLIENTEDGE, 
		"listbox", 
		NULL, 
		LBS_NOTIFY | LBS_SORT | LBS_NOINTEGRALHEIGHT | LBS_WANTKEYBOARDINPUT | WS_CHILD | WS_VISIBLE | WS_VSCROLL,
		5, 5, 180, 99,
		g_qeglobals.d_hwndEntity,
		(void *)IDC_E_LIST,
		g_qeglobals.d_hInstance,
		NULL);
	if (!g_hwndEnt[ENT_LIST])
		Error("CreateWindowEx: Failed.");

	g_hwndEnt[ENT_PROPS] = CreateWindowEx(WS_EX_CLIENTEDGE, 
		"listbox", 
		NULL, 
		LBS_NOTIFY | LBS_SORT | LBS_NOINTEGRALHEIGHT | LBS_USETABSTOPS | WS_CHILD | WS_VISIBLE | WS_VSCROLL,
		5, 100, 180, 99,
		g_qeglobals.d_hwndEntity,
		(void *)IDC_E_PROPS,
		g_qeglobals.d_hInstance,
		NULL);
	if (!g_hwndEnt[ENT_PROPS])
		Error("CreateWindowEx: Failed.");

	g_hwndEnt[ENT_COMMENT] = CreateWindowEx(WS_EX_CLIENTEDGE, 
		"edit", 
		NULL, 
		ES_MULTILINE | ES_READONLY | WS_CHILD | WS_TABSTOP | WS_VISIBLE | WS_VSCROLL,
		5, 100, 180, 99,
		g_qeglobals.d_hwndEntity,
		(void *)IDC_E_COMMENT,
		g_qeglobals.d_hInstance,
		NULL);
	if (!g_hwndEnt[ENT_COMMENT])
		Error("CreateWindowEx: Failed.");

	g_hwndEnt[ENT_KEYFIELD] = CreateWindowEx(WS_EX_CLIENTEDGE, 
		"RichEdit", 
		NULL, 
		ES_AUTOHSCROLL | WS_CHILD | WS_TABSTOP | WS_VISIBLE,
		5, 100, 180, 99,
		g_qeglobals.d_hwndEntity,
		(void *)IDC_E_KEY_FIELD,
		g_qeglobals.d_hInstance,
		NULL);
	if (!g_hwndEnt[ENT_KEYFIELD])
		Error("CreateWindowEx: Failed.");

	g_hwndEnt[ENT_VALUEFIELD] = CreateWindowEx(WS_EX_CLIENTEDGE, 
		"RichEdit", 
		NULL, 
		ES_AUTOHSCROLL | WS_CHILD | WS_TABSTOP | WS_VISIBLE,
		5, 100, 180, 99,
		g_qeglobals.d_hwndEntity,
		(void *)IDC_E_VALUE_FIELD,
		g_qeglobals.d_hInstance,
		NULL);
	if (!g_hwndEnt[ENT_VALUEFIELD])
		Error("CreateWindowEx: Failed.");

	g_qeglobals.d_hwndConsole = CreateWindowEx(WS_EX_CLIENTEDGE, 
		"RichEdit", 
		NULL, 
		ES_MULTILINE | ES_READONLY | WS_CHILD | WS_TABSTOP | WS_VISIBLE | WS_VSCROLL,
		5, 100, 180, 99,
		g_qeglobals.d_hwndEntity,
		(void *)IDC_E_STATUS,
		g_qeglobals.d_hInstance,
		NULL);
	if (!g_qeglobals.d_hwndConsole)
		Error("CreateWindowEx: Failed.");
// <---sikk

	g_qeglobals.d_hwndTexture = WTex_Create(g_qeglobals.d_hInstance);

#if 0
	for (i = 0; i < 12; i++)
	{
		g_hwndEnt[ENT_CHECK1 + i] = CreateWindow("button", 
			NULL, 
			BS_AUTOCHECKBOX | WS_CHILD | WS_VISIBLE,
			5, 100, 180, 99,
			entwindow,
			(void *)IDC_E_STATUS,
			main_instance,
			NULL);
		if (!g_hwndEnt[ENT_CHECK1 + i])
			Error("CreateWindow: Failed.");
	}
#endif

	SendMessage(g_hwndEnt[ENT_LIST], WM_SETFONT, (WPARAM)GetStockObject(DEFAULT_GUI_FONT), (LPARAM)TRUE);
	SendMessage(g_hwndEnt[ENT_PROPS], WM_SETFONT, (WPARAM)GetStockObject(DEFAULT_GUI_FONT), (LPARAM)TRUE);
	SendMessage(g_hwndEnt[ENT_COMMENT], WM_SETFONT, (WPARAM)GetStockObject(DEFAULT_GUI_FONT), (LPARAM)TRUE);
	SendMessage(g_hwndEnt[ENT_KEYFIELD], WM_SETFONT, (WPARAM)GetStockObject(DEFAULT_GUI_FONT), (LPARAM)TRUE);
	SendMessage(g_hwndEnt[ENT_VALUEFIELD], WM_SETFONT, (WPARAM)GetStockObject(DEFAULT_GUI_FONT), (LPARAM)TRUE);

    SendMessage(g_qeglobals.d_hwndConsole, WM_SETFONT, (WPARAM)GetStockObject(DEFAULT_GUI_FONT), (LPARAM)TRUE);
}


/*
===============================================================

ENTITY WINDOW

===============================================================
*/

/*
==============
FillClassList
==============
*/
void FillClassList ()
{
	eclass_t   *pec;
	int			iIndex;

	SendMessage(g_hwndEnt[ENT_LIST], LB_RESETCONTENT, 0 , 0);

	for (pec = g_pecEclass; pec; pec = pec->next)
	{
		iIndex = SendMessage(g_hwndEnt[ENT_LIST], LB_ADDSTRING, 0 , (LPARAM)pec->name);
		SendMessage(g_hwndEnt[ENT_LIST], LB_SETITEMDATA, iIndex, (LPARAM)pec);
	}	

}

/*
==============
WEnt_Create
==============
*/
void WEnt_Create (HINSTANCE hInstance)
{
    WNDCLASS   wc;

    /* Register the entity class */
	memset(&wc, 0, sizeof(wc));

    wc.style         = 0;
    wc.lpfnWndProc   = (WNDPROC)EntityWndProc;
    wc.cbClsExtra    = 0;
    wc.cbWndExtra    = 0;
    wc.hInstance     = hInstance;
    wc.hIcon         = 0;
    wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = (HBRUSH)(COLOR_3DFACE + 1);	// sikk - was-> GetStockObject (LTGRAY_BRUSH);
    wc.lpszMenuName  = NULL;
    wc.lpszClassName = ENT_WINDOW_CLASS;

    if (!RegisterClass(&wc))
        Error("WEnt_Register: Failed.");

// sikk---> changed window to "tool window"
	g_qeglobals.d_hwndEntity = CreateWindowEx(
		WS_EX_TOOLWINDOW,							// Extended window style
		ENT_WINDOW_CLASS ,							// registered class name
		"Entity View",								// window name
		QE3_CHILD_STYLE,							// window style
		g_nScreenWidth - 320, g_nScreenHeight - 520,	// position of window
		100, 480,									// window size
		g_qeglobals.d_hwndMain,						// parent or owner window
		0,											// menu or child-window identifier
		hInstance,									// application instance
		NULL);										// window-creation data
// <---sikk

	if (!g_qeglobals.d_hwndEntity)
		Error("Could not create Entity Window.");
}

/*
==============
CreateEntityWindow
==============
*/
void CreateEntityWindow (HINSTANCE hInstance)
{
	HWND h;

	g_qeglobals.d_nInspectorMode = W_ENTITY;

	WEnt_Create(hInstance);

	h = CreateDialog(hInstance, (char *)IDD_ENTITY, g_qeglobals.d_hwndMain, (DLGPROC)NULL);
	if (!h)
		Error("CreateDialog: Failed.");

	GetEntityControls(h);
	DestroyWindow(h);

	OldFieldWindowProc = (void *)GetWindowLong(g_hwndEnt[ENT_KEYFIELD], GWL_WNDPROC);
	SetWindowLong(g_hwndEnt[ENT_KEYFIELD], GWL_WNDPROC, (long)FieldWndProc);
	SetWindowLong(g_hwndEnt[ENT_VALUEFIELD], GWL_WNDPROC, (long)FieldWndProc);

	OldEntityListWindowProc = (void *)GetWindowLong(g_hwndEnt[ENT_LIST], GWL_WNDPROC);
	SetWindowLong(g_hwndEnt[ENT_LIST], GWL_WNDPROC, (long)EntityListWndProc);

	FillClassList();

	LoadWindowState(g_qeglobals.d_hwndEntity, "EntityWindow");

	ShowWindow(g_qeglobals.d_hwndEntity, SW_SHOW);
	SetInspectorMode(W_CONSOLE);
}

/*
==============
SetInspectorMode
==============
*/
void SetInspectorMode (int nType)
{
	RECT	rc;
	HMENU	hMenu = GetMenu(g_qeglobals.d_hwndMain);

	// Is the caller asking us to cycle to the next window?
	if (nType == -1)
	{
		if (g_qeglobals.d_nInspectorMode == W_ENTITY)
			nType = W_TEXTURE;
		else if (g_qeglobals.d_nInspectorMode == W_TEXTURE)
			nType = W_CONSOLE;
		else
			nType = W_ENTITY;
	}		

	g_qeglobals.d_nInspectorMode = nType;
	switch(nType)
	{
	case W_ENTITY:
		SetWindowText(g_qeglobals.d_hwndEntity, "Entities");
		EnableMenuItem(hMenu, ID_MISC_SELECTENTITYCOLOR, MF_ENABLED);
		break;

	case W_TEXTURE:
//		SetWindowText(g_qeglobals.d_hwndEntity, "Textures"); // title is set by textures.c
		EnableMenuItem(hMenu, ID_MISC_SELECTENTITYCOLOR, MF_GRAYED | MF_DISABLED);
		break;

	case W_CONSOLE:
		SetWindowText(g_qeglobals.d_hwndEntity, "Console");		
		EnableMenuItem(hMenu, ID_MISC_SELECTENTITYCOLOR, MF_GRAYED | MF_DISABLED);
		break;

	default:
		break;
	}

	GetWindowRect(g_qeglobals.d_hwndEntity, &rc);
	SizeEntityDlg(rc.right - rc.left - 8, rc.bottom - rc.top - 32);

	RedrawWindow(g_qeglobals.d_hwndEntity, NULL, NULL, 
				 RDW_ERASE | RDW_INVALIDATE | RDW_ERASENOW | RDW_UPDATENOW | RDW_ALLCHILDREN);

	SetWindowPos(g_qeglobals.d_hwndEntity, HWND_TOP, 
				 rc.left, rc.top, rc.right - rc.left, rc.bottom - rc.top, 
				 SWP_NOSIZE | SWP_NOMOVE);
}

/*
==============
SetKeyValuePairs

Reset the key/value (aka property) listbox and fill it with the 
k/v pairs from the entity being edited.
==============
*/
void SetKeyValuePairs ()
{
	epair_t	   *pep;
	RECT		rc;
	char		sz[4096];

	if (g_peEditEntity == NULL)
		return;

	// set key/value pair list
	GetWindowRect(g_hwndEnt[ENT_PROPS], &rc);
	SendMessage(g_hwndEnt[ENT_PROPS], LB_SETCOLUMNWIDTH, (rc.right - rc.left) / 2, 0);
	SendMessage(g_hwndEnt[ENT_PROPS], LB_RESETCONTENT, 0, 0);

	// Walk through list and add pairs
	for (pep = g_peEditEntity->epairs; pep; pep = pep->next)
	{
		// if the key is less than 8 chars, add a tab for alignment
		if (strlen(pep->key) > 8)
			sprintf(sz, "%s\t%s", pep->key, pep->value);
		else
			sprintf(sz, "%s\t\t%s", pep->key, pep->value);

		SendMessage(g_hwndEnt[ENT_PROPS], LB_ADDSTRING, 0, (LPARAM)sz);
	}

}

/*
==============
SetSpawnFlags

Update the checkboxes to reflect the flag state of the entity
==============
*/
void SetSpawnFlags ()
{
	int		f, i, v;

	f = atoi(ValueForKey(g_peEditEntity, "spawnflags"));
	for (i = 0; i < 12; i++)
	{
		v = !!(f & (1 << i));
		SendMessage(g_hwndEnt[ENT_CHECK1 + i], BM_SETCHECK, v, 0);
	}
}

/*
==============
GetSpawnFlags

Update the entity flags to reflect the state of the checkboxes
==============
*/
void GetSpawnFlags ()
{
	int		f;
	int		i, v;
	char	sz[32];

	f = 0;
	for (i = 0; i < 12; i++)
	{
		v = SendMessage(g_hwndEnt[ENT_CHECK1 + i], BM_GETCHECK, 0, 0);
		f |= v << i;
	}

	sprintf(sz, "%d", f);

	if (g_bMultipleEntities)
	{
		brush_t	*b;

		for (b = g_brSelectedBrushes.next; b != &g_brSelectedBrushes; b = b->next)
			SetKeyValue(b->owner, "spawnflags", sz);
	}
	else
		SetKeyValue(g_peEditEntity, "spawnflags", sz);

	SetKeyValuePairs();
}

/*
==============
UpdateSel

Update the listbox, checkboxes and k/v pairs to reflect the new selection
==============
*/
bool UpdateSel (int nIndex, eclass_t *pec)
{
	int			i;
	brush_t	   *b;

	if (g_brSelectedBrushes.next == &g_brSelectedBrushes)
	{
		g_peEditEntity = g_peWorldEntity;
		g_bMultipleEntities = false;
	}
	else
	{
		g_peEditEntity = g_brSelectedBrushes.next->owner;
		for (b = g_brSelectedBrushes.next->next; b != &g_brSelectedBrushes; b = b->next)
		{
			if (b->owner != g_peEditEntity)
			{
				g_bMultipleEntities = true;
				break;
			}
		}
	}

	if (nIndex != LB_ERR)
		SendMessage(g_hwndEnt[ENT_LIST], LB_SETCURSEL, nIndex, 0);

	if (pec == NULL)
		return true;

	// Set up the description
	SendMessage(g_hwndEnt[ENT_COMMENT], WM_SETTEXT, 0, (LPARAM)TranslateString(pec->comments));

	for (i = 0; i < 8; i++)
	{
		HWND hwnd = g_hwndEnt[ENT_CHECK1 + i];
		if (pec->flagnames[i] && pec->flagnames[i][0] != 0)
		{
			EnableWindow(hwnd, TRUE);
			SendMessage(hwnd, WM_SETTEXT, 0, (LPARAM)pec->flagnames[i]);
		} 
		else 
		{
			// disable check box
			SendMessage(hwnd, WM_SETTEXT, 0, (LPARAM)" ");
			EnableWindow(hwnd, FALSE);
		}
	}

	SetSpawnFlags();
	SetKeyValuePairs();
	return false;
}

/*
==============
UpdateEntitySel
==============
*/
bool UpdateEntitySel (eclass_t *pec)
{
	int iIndex;
	
	iIndex = (int)SendMessage(g_hwndEnt[ENT_LIST], LB_FINDSTRINGEXACT, (WPARAM)-1, (LPARAM)pec->name);

	return UpdateSel(iIndex, pec);
}

/*
==============
CreateEntity

Creates a new entity based on the currently selected brush and entity type.
==============
*/
void CreateEntity ()
{
	eclass_t   *pecNew;
	entity_t   *petNew;
	int			i;
	HWND		hwnd;
	char		sz[1024];

	// check to make sure we have a brush
	if (g_brSelectedBrushes.next == &g_brSelectedBrushes)
	{
	    MessageBox(g_qeglobals.d_hwndMain, "You must have a brush selected to create an entity.", "QuakeEd 3: Entity Creation Info", MB_OK | MB_ICONINFORMATION);
		return;
	}

	// find out what type of entity we are trying to create
	hwnd = g_hwndEnt[ENT_LIST];

	i = SendMessage(g_hwndEnt[ENT_LIST], LB_GETCURSEL, 0, 0);

	if (i < 0)
	{
	    MessageBox(g_qeglobals.d_hwndMain, "You must have a class selected to create an entity.", "QuakeEd 3: Entity Creation Info", MB_OK | MB_ICONINFORMATION);
		return;
	}

	SendMessage(hwnd, LB_GETTEXT, i, (LPARAM)sz);

	if (!stricmp(sz, "worldspawn"))
	{
	    MessageBox(g_qeglobals.d_hwndMain, "Can't create a new worldspawn entity.", "QuakeEd 3: Entity Creation Info", MB_OK | MB_ICONINFORMATION);
		return;
	}

	Undo_Start("Create Entity");	// sikk - Undo/Redo
	Undo_AddBrushList(&g_brSelectedBrushes);

	pecNew = Eclass_ForName(sz, false);

	// create it
	petNew = Entity_Create(pecNew);

	if (petNew == NULL)
	{
	    MessageBox(g_qeglobals.d_hwndMain, "Failed to create entity.", "QuakeEd 3: Entity Creation Error", MB_OK | MB_ICONEXCLAMATION);
		return;
	}

	if (g_brSelectedBrushes.next == &g_brSelectedBrushes)
		g_peEditEntity = g_peWorldEntity;
	else
		g_peEditEntity = g_brSelectedBrushes.next->owner;

	SetKeyValuePairs();
	Select_Deselect(true);
	Select_Brush(g_peEditEntity->brushes.onext, true);

	Undo_EndBrushList(&g_brSelectedBrushes);
	Undo_End();	// sikk - Undo/Redo
}

/*
===============
AddProp
===============
*/
void AddProp ()
{
	char	key[4096];
	char	value[4096];

	if (g_peEditEntity == NULL)
		return;

	// Get current selection text
	SendMessage(g_hwndEnt[ENT_KEYFIELD], WM_GETTEXT, sizeof(key) - 1, (LPARAM)key);	
	SendMessage(g_hwndEnt[ENT_VALUEFIELD], WM_GETTEXT, sizeof(value) - 1, (LPARAM)value);	

	if (g_bMultipleEntities)
	{
		brush_t	*b;

		for (b = g_brSelectedBrushes.next; b != &g_brSelectedBrushes; b = b->next)
			SetKeyValue(b->owner, key, value);
	}
	else
		SetKeyValue(g_peEditEntity, key, value);

	// refresh the prop listbox
	SetKeyValuePairs();	
}

/*
===============
DelProp
===============
*/
void DelProp ()
{
	char	sz[4096];

	if (g_peEditEntity == NULL)
		return;

	// Get current selection text
	SendMessage(g_hwndEnt[ENT_KEYFIELD], WM_GETTEXT, sizeof(sz) - 1, (LPARAM)sz);	

	if (g_bMultipleEntities)
	{
		brush_t	*b;

		for (b = g_brSelectedBrushes.next; b != &g_brSelectedBrushes; b = b->next)
			DeleteKey(b->owner, sz);
	}
	else
		DeleteKey(g_peEditEntity, sz);

	// refresh the prop listbox
	SetKeyValuePairs();	
}

/*
===============
EditProp
===============
*/
void EditProp ()
{
	int		i;
	HWND	hwnd;
	char	sz[4096];
	char   *val;

	if (g_peEditEntity == NULL)
		return;

	hwnd = g_hwndEnt[ENT_PROPS];

	// Get current selection text
	i = SendMessage(hwnd, LB_GETCURSEL, 0, 0);	

	if (i < 0)
		return;

	SendMessage(hwnd, LB_GETTEXT, i, (LPARAM)sz);	

	// strip it down to the key name
	for (i = 0; sz[i] != '\t'; i++)
		;

	sz[i] = '\0';

	val = sz + i + 1;
	if (*val == '\t')
		val++;

	SendMessage(g_hwndEnt[ENT_KEYFIELD], WM_SETTEXT, 0, (LPARAM)sz);	
	SendMessage(g_hwndEnt[ENT_VALUEFIELD], WM_SETTEXT, 0, (LPARAM)val);	
}

//HDWP	defer;	// sikk - unused
int		g_nCol;

/*
==============
MOVE
==============
*/
void MOVE (HWND e, int x, int y, int w, int h)
{
	SetWindowPos(e, HWND_TOP, g_nCol + x, y, w, h, SWP_NOACTIVATE | SWP_NOCOPYBITS | SWP_NOZORDER);
}

/*
===============
SizeEnitityDlg

Positions all controls so that the active inspector
is displayed correctly and the inactive ones are
off the side
===============
*/
void SizeEntityDlg (int nWidth, int nHeight)
{
	int		y, x, xCheck, yCheck;
	int		i, iRow;
	int		w, h;

	if (nWidth < 32 || nHeight < 32)
		return;

	SendMessage(g_qeglobals.d_hwndEntity, WM_SETREDRAW, 0, 0);

	//==========================================

	//
	// console
	//
	if (g_qeglobals.d_nInspectorMode == W_CONSOLE)
		g_nCol = 0;
	else
		g_nCol = nWidth;

	MOVE(g_qeglobals.d_hwndConsole, DLGBORDER_X, DLGBORDER_Y, nWidth - (2 * DLGBORDER_X), nHeight - (2 * DLGBORDER_Y));

	//==========================================

	//
	// texture controls
	//
	if (g_qeglobals.d_nInspectorMode == W_TEXTURE)
		g_nCol = 0;
	else
		g_nCol = nWidth;

	MOVE(g_qeglobals.d_hwndTexture,	DLGBORDER_X, DLGBORDER_Y, nWidth - (2 * DLGBORDER_X), nHeight - (2 * DLGBORDER_Y));

	//==========================================

	//
	// entity controls
	//
	if (g_qeglobals.d_nInspectorMode == W_ENTITY)
		g_nCol = 0;
	else
		g_nCol = nWidth;


	// top half includes the entity list (2/3) and the 
	// comments (1/3) - 2 gaps, above and below.

	y = nHeight / 2;
	y -= 2 * DLGBORDER_Y;
	y = y / 3;
	w = nWidth - (2 * DLGBORDER_X);
	MOVE(g_hwndEnt[ENT_LIST], DLGBORDER_X, DLGBORDER_Y, w, 2 * y);
	
	MOVE(g_hwndEnt[ENT_COMMENT], DLGBORDER_X, 2 * DLGBORDER_Y + 2 * y, w, y - (2 * DLGBORDER_Y));

	// bottom half includes flags (fixed), k/v pairs,
	// and buttons (fixed).

	// xCheck = width of a single check box
	// yCheck = distance from top of one check to the next
	xCheck = (nWidth - (2 * DLGBORDER_X)) / 3;
	yCheck = 20;

	x = DLGBORDER_X;

	for (iRow = 0; iRow <= 12; iRow += 4)
	{
		y = nHeight / 2;
	
		for (i = 0; i < 4; i++)
		{
			MOVE(g_hwndEnt[ENT_CHECK1 + i + iRow],	x, y, xCheck, yCheck);
			y += yCheck;
		}

		x += xCheck;
	}

	//
	// properties scroll box
	//
	y = nHeight / 2 + 4 * yCheck;

	w = nWidth - (2 * DLGBORDER_X);
	h = (nHeight - (yCheck * 5 + 2 * DLGBORDER_Y)) - y;

	MOVE(g_hwndEnt[ENT_PROPS], DLGBORDER_X, y, w, h);

	y += h + DLGBORDER_Y;
	
	//
	// key / value fields
	//
	w = nWidth - (DLGBORDER_X + 45);
	MOVE(g_hwndEnt[ENT_KEYLABEL], DLGBORDER_X, y, 40, yCheck);
	MOVE(g_hwndEnt[ENT_KEYFIELD], DLGBORDER_X + 40, y, w, yCheck);
	y += yCheck;		

	MOVE(g_hwndEnt[ENT_VALUELABEL], DLGBORDER_X, y + 2, 40, yCheck);
	MOVE(g_hwndEnt[ENT_VALUEFIELD], DLGBORDER_X + 40, y + 2, w, yCheck);
	y += yCheck;		

	//
	// angle check boxes
	//
	i = y + 6;	// sikk - Minor adjustment (added: '+ 6';) 
	x = DLGBORDER_X;

	xCheck = yCheck + 8;// * 2;

	MOVE(g_hwndEnt[ENT_DIR135], x, y + 6, xCheck, yCheck);	// sikk - Minor adjustment (added: '+ 6';) 
	y += yCheck + 6;	// sikk - Minor adjustment (added: '+ 6';) 		
	
	MOVE(g_hwndEnt[ENT_DIR180], x, y, xCheck, yCheck);
	y += yCheck;		
	
	MOVE(g_hwndEnt[ENT_DIR225], x, y, xCheck, yCheck);

	y = i;
	x += xCheck;

	
	MOVE(g_hwndEnt[ENT_DIR90], x, y, xCheck, yCheck);
	y += yCheck;		
	y += yCheck;		
	
	MOVE(g_hwndEnt[ENT_DIR270], x, y, xCheck, yCheck);

	y = i;
	x += xCheck;

	
	MOVE(g_hwndEnt[ENT_DIR45], x, y, xCheck, yCheck);
	y += yCheck;		
	
	MOVE(g_hwndEnt[ENT_DIR0], x, y, xCheck, yCheck);
	y += yCheck;		
	
	MOVE(g_hwndEnt[ENT_DIR315], x, y, xCheck, yCheck);

	y = i + yCheck / 2;
	x += xCheck + xCheck / 2;

	
	MOVE(g_hwndEnt[ENT_DIRUP], x, y, xCheck, yCheck);
	y += yCheck;		
	
	MOVE(g_hwndEnt[ENT_DIRDOWN], x, y, xCheck, yCheck);


	y = i;
	x += 2 * xCheck;
	
	MOVE(g_hwndEnt[ENT_ADDPROP], x, y, xCheck + 24, yCheck);	// sikk - Entity Window Addition
	y += yCheck;

	MOVE(g_hwndEnt[ENT_DELPROP], x, y, xCheck + 24, yCheck);
	y += yCheck;		

	MOVE(g_hwndEnt[ENT_COLOR], x, y, xCheck + 24, yCheck);	// sikk - Entity Window Addition
	x += xCheck * 2.5;
	y += yCheck - yCheck * 2.5;

	MOVE(g_hwndEnt[ENT_CREATE], x, y, xCheck * 2.5, yCheck + 16);	// sikk - Entity Window Addition
	y += yCheck;		

	SendMessage(g_qeglobals.d_hwndEntity, WM_SETREDRAW, 1, 0);
//	InvalidateRect(entwindow, NULL, TRUE);
}

/*
=========================
EntityWndProc
=========================
*/
BOOL CALLBACK EntityWndProc (
    HWND	hwndDlg,// handle to dialog box
    UINT	uMsg,	// message
    WPARAM	wParam,	// first message parameter
    LPARAM	lParam	// second message parameter
	)
{
	RECT	rc;

	GetClientRect(hwndDlg, &rc);

    switch (uMsg)
    {
	case WM_GETMINMAXINFO:
		{
			LPMINMAXINFO lpmmi = (LPMINMAXINFO)lParam;;
			lpmmi->ptMinTrackSize.x = 320;
			lpmmi->ptMinTrackSize.y = 480; // 500
		}
		return 0;

	case WM_WINDOWPOSCHANGING:
		{
			LPWINDOWPOS lpwp = (LPWINDOWPOS)lParam;
			DefWindowProc(hwndDlg, uMsg, wParam, lParam);
			lpwp->flags |= SWP_NOCOPYBITS;
			SizeEntityDlg(lpwp->cx - 8, lpwp->cy - 32);
		}
		return 0;

// sikk---> Window Management
	case WM_SIZING:
		if (TryDocking(hwndDlg, wParam, (LPRECT)lParam, 300))
			return TRUE;
		break;

	case WM_MOVING:
		if (TryDocking(hwndDlg, wParam, (LPRECT)lParam, 0))
			return TRUE;
		break;
// <---sikk

	case WM_COMMAND: 
		switch (LOWORD(wParam)) 
		{
		case IDC_E_CREATE:
			if (GetTopWindow(g_qeglobals.d_hwndMain) != hwndDlg)
				BringWindowToTop(hwndDlg);
			CreateEntity();
			SetFocus(g_qeglobals.d_hwndCamera);
			break;
		case IDC_E_COLOR:
			if (GetTopWindow(g_qeglobals.d_hwndMain) != hwndDlg)
				BringWindowToTop(hwndDlg);
			if ((g_qeglobals.d_nInspectorMode == W_ENTITY) && DoColor(COLOR_ENTITY) == true)
			{
				extern void AddProp(void);
				
				char buffer[64];
				
				sprintf(buffer, "%f %f %f", g_qeglobals.d_savedinfo.v3Colors[COLOR_ENTITY][0],
											g_qeglobals.d_savedinfo.v3Colors[COLOR_ENTITY][1],
											g_qeglobals.d_savedinfo.v3Colors[COLOR_ENTITY][2]);
					
				SetWindowText(g_hwndEnt[ENT_KEYFIELD], "_color");
				SetWindowText(g_hwndEnt[ENT_VALUEFIELD], buffer);
				AddProp();
			}
			Sys_UpdateWindows(W_ALL);
			SetFocus(g_qeglobals.d_hwndCamera);
			break;

		case IDC_E_ADDPROP:
			if (GetTopWindow(g_qeglobals.d_hwndMain) != hwndDlg)
				BringWindowToTop(hwndDlg);
			AddProp();
			SetFocus(g_qeglobals.d_hwndCamera);
			break;
		case IDC_E_DELPROP:
			if (GetTopWindow(g_qeglobals.d_hwndMain) != hwndDlg)
				BringWindowToTop(hwndDlg);
			DelProp();
			SetFocus(g_qeglobals.d_hwndCamera);
			break;
		case IDC_E_0:
			if (GetTopWindow(g_qeglobals.d_hwndMain) != hwndDlg)
				BringWindowToTop(hwndDlg);
			SetKeyValue(g_peEditEntity, "angle", "0");
			SetFocus(g_qeglobals.d_hwndCamera);
			SetKeyValuePairs();
			break;
		case IDC_E_45:
			if (GetTopWindow(g_qeglobals.d_hwndMain) != hwndDlg)
				BringWindowToTop(hwndDlg);
			SetKeyValue(g_peEditEntity, "angle", "45");
			SetFocus(g_qeglobals.d_hwndCamera);
			SetKeyValuePairs();
			break;
		case IDC_E_90:
			if (GetTopWindow(g_qeglobals.d_hwndMain) != hwndDlg)
				BringWindowToTop(hwndDlg);
			SetKeyValue(g_peEditEntity, "angle", "90");
			SetFocus(g_qeglobals.d_hwndCamera);
			SetKeyValuePairs();
			break;
		case IDC_E_135:
			if (GetTopWindow(g_qeglobals.d_hwndMain) != hwndDlg)
				BringWindowToTop(hwndDlg);
			SetKeyValue(g_peEditEntity, "angle", "135");
			SetFocus(g_qeglobals.d_hwndCamera);
			SetKeyValuePairs();
			break;
		case IDC_E_180:
			if (GetTopWindow(g_qeglobals.d_hwndMain) != hwndDlg)
				BringWindowToTop(hwndDlg);
			SetKeyValue(g_peEditEntity, "angle", "180");
			SetFocus(g_qeglobals.d_hwndCamera);
			SetKeyValuePairs();
			break;
		case IDC_E_225:
			if (GetTopWindow(g_qeglobals.d_hwndMain) != hwndDlg)
				BringWindowToTop(hwndDlg);
			SetKeyValue(g_peEditEntity, "angle", "225");
			SetFocus(g_qeglobals.d_hwndCamera);
			SetKeyValuePairs();
			break;
		case IDC_E_270:
			if (GetTopWindow(g_qeglobals.d_hwndMain) != hwndDlg)
				BringWindowToTop(hwndDlg);
			SetKeyValue(g_peEditEntity, "angle", "270");
			SetFocus(g_qeglobals.d_hwndCamera);
			SetKeyValuePairs();
			break;
		case IDC_E_315:
			if (GetTopWindow(g_qeglobals.d_hwndMain) != hwndDlg)
				BringWindowToTop(hwndDlg);
			SetKeyValue(g_peEditEntity, "angle", "315");
			SetFocus(g_qeglobals.d_hwndCamera);
			SetKeyValuePairs();
			break;
		case IDC_E_UP:
			if (GetTopWindow(g_qeglobals.d_hwndMain) != hwndDlg)
				BringWindowToTop(hwndDlg);
			SetKeyValue(g_peEditEntity, "angle", "-1");
			SetFocus(g_qeglobals.d_hwndCamera);
			SetKeyValuePairs();
			break;
		case IDC_E_DOWN:
			if (GetTopWindow(g_qeglobals.d_hwndMain) != hwndDlg)
				BringWindowToTop(hwndDlg);
			SetKeyValue(g_peEditEntity, "angle", "-2");
			SetFocus(g_qeglobals.d_hwndCamera);
			SetKeyValuePairs();
			break;

		case IDC_E_FLAG1:
		case IDC_E_FLAG2:
		case IDC_E_FLAG3:
		case IDC_E_FLAG4:
		case IDC_E_FLAG5:
		case IDC_E_FLAG6:
		case IDC_E_FLAG7:
		case IDC_E_FLAG8:
		case IDC_E_FLAG9:
		case IDC_E_FLAG10:
		case IDC_E_FLAG11:
		case IDC_E_FLAG12:
			if (GetTopWindow(g_qeglobals.d_hwndMain) != hwndDlg)
				BringWindowToTop(hwndDlg);
			GetSpawnFlags();
			SetFocus(g_qeglobals.d_hwndCamera);
			break;

		case IDC_E_PROPS: 
			switch (HIWORD(wParam))
			{ 
			case LBN_SELCHANGE:
				if (GetTopWindow(g_qeglobals.d_hwndMain) != hwndDlg)
					BringWindowToTop(hwndDlg);

				EditProp();
				return TRUE; 
			}
			break;

		case IDC_E_LIST: 
	   		switch (HIWORD(wParam)) 
			{ 
			case LBN_SELCHANGE: 
				{
					int			iIndex;
					eclass_t   *pec;

					if (GetTopWindow(g_qeglobals.d_hwndMain) != hwndDlg)
						BringWindowToTop(hwndDlg);

					iIndex = SendMessage(g_hwndEnt[ENT_LIST], LB_GETCURSEL, 0, 0);	
					pec = (eclass_t *)SendMessage(g_hwndEnt[ENT_LIST], LB_GETITEMDATA, iIndex, 0); 
				
					UpdateSel(iIndex, pec);

					return TRUE; 
					break; 
				}

			case LBN_DBLCLK: 
				CreateEntity();
				SetFocus(g_qeglobals.d_hwndCamera);
				break; 
			} 
            break; 

		default: 
			return DefWindowProc(hwndDlg, uMsg, wParam, lParam);
        } 
		return 0;

// sikk---> LMB Bring to Top
	case WM_LBUTTONDOWN:
		if (GetTopWindow(g_qeglobals.d_hwndMain) != hwndDlg)
			BringWindowToTop(hwndDlg);
		break;
// <---sikk
	}
    return DefWindowProc(hwndDlg, uMsg, wParam, lParam);
}
