//==============================
//	win_main.c
//==============================

#include "qe3.h"
#include <process.h>
#include "io.h"


// sikk---> Show/Hide window
bool g_bShowEntity = true;
bool g_bShowConsole = true;
bool g_bShowTexture = true;
// <---sikk

/*
==============================================================================

	MENU

==============================================================================
*/

// sikk---> Texture Popup Menu
/*
============
DoTexturesPopup
============
*/
void DoTexturesPopup ()
{
	BOOL	retval;
	POINT	point;

	HMENU	menu = GetSubMenu(LoadMenu(g_qeglobals.d_hInstance, MAKEINTRESOURCE(IDR_POPUP_TEXTURE)), 0);

	GetCursorPos(&point);

	retval = TrackPopupMenu(menu, TPM_LEFTALIGN | TPM_NONOTIFY | TPM_RETURNCMD | TPM_RIGHTBUTTON, point.x, point.y, 0, g_qeglobals.d_hwndRebar, NULL);

	PostMessage(g_qeglobals.d_hwndMain, WM_COMMAND, retval, 0);

	DestroyMenu(menu);
}
// <---sikk

/*
==============
RunBsp
==============
*/
void RunBsp (char *command)
{
	char	sys[1024];
	char	batpath[1024];
	char	outputpath[1024];
	char	temppath[1024];
	char	name[1024];
	char   *basepath;
	FILE   *hFile;
	BOOL	ret;
	STARTUPINFO	startupinfo;
	PROCESS_INFORMATION	ProcessInformation;

	SetInspectorMode(W_CONSOLE);

	if (g_hBSP_Process)
	{
		Sys_Printf("MSG: BSP is still running...\n");
		return;
	}

	GetTempPath(1024, temppath);
	sprintf(outputpath, "%sjunk.txt", temppath);

	strcpy(name, g_szCurrentMap);
	if (g_bRegionActive)
	{
		Map_SaveFile(name, false);
		StripExtension(name);
		strcat(name, ".reg");
	}

	Map_SaveFile(name, g_bRegionActive);

	QE_ExpandBspString(command, sys, name);

//	Sys_ClearPrintf();
	Sys_Printf("======================================\nCMD: Running BSP...\n");
	Sys_Printf("\n%s\n", sys);

	//
	// write qe3bsp.bat
	//
	sprintf(batpath, "%sqe3bsp.bat", temppath);
	hFile = fopen(batpath, "w");
	if (!hFile)
		Error("Cannot write to %s", batpath);
	fprintf(hFile, sys);
	fclose(hFile);

// sikk - TODO: This will be changed when I find a way for realtime progress to console
	//
	// write qe3bsp2.bat
	//
	sprintf(batpath, "%sqe3bsp2.bat", temppath);
	hFile = fopen(batpath, "w");
	if (!hFile)
		Error("Cannot write to %s", batpath);
	fprintf(hFile, "%sqe3bsp.bat > %s", temppath, outputpath);
	fclose(hFile);

	Pointfile_Delete();

	basepath = ValueForKey(g_qeglobals.d_entityProject, "basepath");
	if(basepath && !(*basepath))
		basepath = NULL;

	GetStartupInfo(&startupinfo);

	ret = CreateProcess(
			batpath,				// pointer to name of executable module
			NULL,					// pointer to command line string
			NULL,					// pointer to process security attributes
			NULL,					// pointer to thread security attributes
			FALSE,					// handle inheritance flag
			0 /*DETACHED_PROCESS*/,	// creation flags
			NULL,					// pointer to new environment block
			basepath,				// pointer to current directory name
			&startupinfo,			// pointer to STARTUPINFO
			&ProcessInformation 	// pointer to PROCESS_INFORMATION
			);

	if (!ret)
		Error("CreateProcess: Failed.");

	g_hBSP_Process = ProcessInformation.hProcess;

	Sleep(100);	// give the new process a chance to open it's window

	BringWindowToTop(g_qeglobals.d_hwndMain);	// pop us back on top
	SetFocus(g_qeglobals.d_hwndCamera);
}

/*
=============
DoColor
=============
*/
bool DoColor (int iIndex)
{
	CHOOSECOLOR		cc;
	static COLORREF	custom[16];

	cc.lStructSize = sizeof(cc);
	cc.hwndOwner = g_qeglobals.d_hwndMain;
//	cc.hInstance = g_qeglobals.d_hInstance;
	cc.hInstance = g_qeglobals.d_hInstanceColor;	// eerie
	
	cc.rgbResult = (int)(g_qeglobals.d_savedinfo.v3Colors[iIndex][0] * 255) +
				 (((int)(g_qeglobals.d_savedinfo.v3Colors[iIndex][1] * 255)) << 8) +
				 (((int)(g_qeglobals.d_savedinfo.v3Colors[iIndex][2] * 255)) << 16);
    cc.lpCustColors = custom;
    cc.Flags = CC_FULLOPEN | CC_RGBINIT;
//	cc.lCustData;
//	cc.lpfnHook;
//	cc.lpTemplateName

	if (!ChooseColor(&cc))
		return false;

	g_qeglobals.d_savedinfo.v3Colors[iIndex][0] = (cc.rgbResult & 255) / 255.0;
	g_qeglobals.d_savedinfo.v3Colors[iIndex][1] = ((cc.rgbResult >> 8) & 255) / 255.0;
	g_qeglobals.d_savedinfo.v3Colors[iIndex][2] = ((cc.rgbResult >> 16) & 255) / 255.0;

	/*
	** scale colors so that at least one component is at 1.0F 
	** if this is meant to select an entity color
	*/
	if (iIndex == COLOR_ENTITY)
	{
		float largest = 0.0F;

		if (g_qeglobals.d_savedinfo.v3Colors[iIndex][0] > largest)
			largest = g_qeglobals.d_savedinfo.v3Colors[iIndex][0];
		if (g_qeglobals.d_savedinfo.v3Colors[iIndex][1] > largest)
			largest = g_qeglobals.d_savedinfo.v3Colors[iIndex][1];
		if (g_qeglobals.d_savedinfo.v3Colors[iIndex][2] > largest)
			largest = g_qeglobals.d_savedinfo.v3Colors[iIndex][2];

		if (largest == 0.0F)
		{
			g_qeglobals.d_savedinfo.v3Colors[iIndex][0] = 1.0F;
			g_qeglobals.d_savedinfo.v3Colors[iIndex][1] = 1.0F;
			g_qeglobals.d_savedinfo.v3Colors[iIndex][2] = 1.0F;
		}
		else
		{
			float scaler = 1.0F / largest;

			g_qeglobals.d_savedinfo.v3Colors[iIndex][0] *= scaler;
			g_qeglobals.d_savedinfo.v3Colors[iIndex][1] *= scaler;
			g_qeglobals.d_savedinfo.v3Colors[iIndex][2] *= scaler;
		}
	}

	Sys_UpdateWindows(W_ALL);

	return true;
}

// sikk--> Color Themes
/*
=============
DoTheme
=============
*/
void DoTheme (vec3_t v[])
{
	g_qeglobals.d_savedinfo.v3Colors[COLOR_BRUSHES][0] = v[0][0];
	g_qeglobals.d_savedinfo.v3Colors[COLOR_BRUSHES][1] = v[0][1];
	g_qeglobals.d_savedinfo.v3Colors[COLOR_BRUSHES][2] = v[0][2];

	g_qeglobals.d_savedinfo.v3Colors[COLOR_CAMERABACK][0] = v[1][0];
	g_qeglobals.d_savedinfo.v3Colors[COLOR_CAMERABACK][1] = v[1][1];
	g_qeglobals.d_savedinfo.v3Colors[COLOR_CAMERABACK][2] = v[1][2];

	g_qeglobals.d_savedinfo.v3Colors[COLOR_CAMERAGRID][0] = v[2][0];
	g_qeglobals.d_savedinfo.v3Colors[COLOR_CAMERAGRID][1] = v[2][1];
	g_qeglobals.d_savedinfo.v3Colors[COLOR_CAMERAGRID][2] = v[2][2];

	g_qeglobals.d_savedinfo.v3Colors[COLOR_GRIDBACK][0] = v[3][0];
	g_qeglobals.d_savedinfo.v3Colors[COLOR_GRIDBACK][1] = v[3][1];
	g_qeglobals.d_savedinfo.v3Colors[COLOR_GRIDBACK][2] = v[3][2];

	g_qeglobals.d_savedinfo.v3Colors[COLOR_GRIDBLOCK][0] = v[4][0];
	g_qeglobals.d_savedinfo.v3Colors[COLOR_GRIDBLOCK][1] = v[4][1];
	g_qeglobals.d_savedinfo.v3Colors[COLOR_GRIDBLOCK][2] = v[4][2];

	g_qeglobals.d_savedinfo.v3Colors[COLOR_GRIDMAJOR][0] = v[5][0];
	g_qeglobals.d_savedinfo.v3Colors[COLOR_GRIDMAJOR][1] = v[5][1];
	g_qeglobals.d_savedinfo.v3Colors[COLOR_GRIDMAJOR][2] = v[5][2];

	g_qeglobals.d_savedinfo.v3Colors[COLOR_GRIDMINOR][0] = v[6][0];
	g_qeglobals.d_savedinfo.v3Colors[COLOR_GRIDMINOR][1] = v[6][1];
	g_qeglobals.d_savedinfo.v3Colors[COLOR_GRIDMINOR][2] = v[6][2];

	g_qeglobals.d_savedinfo.v3Colors[COLOR_GRIDTEXT][0] = v[7][0];
	g_qeglobals.d_savedinfo.v3Colors[COLOR_GRIDTEXT][1] = v[7][1];
	g_qeglobals.d_savedinfo.v3Colors[COLOR_GRIDTEXT][2] = v[7][2];

	g_qeglobals.d_savedinfo.v3Colors[COLOR_MAPBOUNDRY][0] = v[8][0];
	g_qeglobals.d_savedinfo.v3Colors[COLOR_MAPBOUNDRY][1] = v[8][1];
	g_qeglobals.d_savedinfo.v3Colors[COLOR_MAPBOUNDRY][2] = v[8][2];

	g_qeglobals.d_savedinfo.v3Colors[COLOR_VIEWNAME][0] = v[9][0];
	g_qeglobals.d_savedinfo.v3Colors[COLOR_VIEWNAME][1] = v[9][1];
	g_qeglobals.d_savedinfo.v3Colors[COLOR_VIEWNAME][2] = v[9][2];

	Sys_UpdateWindows(W_ALL);
}
// <---sikk

/*
==============
DoMru

Copied from MSDN
==============
*/
BOOL DoMru (HWND hWnd, WORD wId)
{
	char		szFileName[128];
	OFSTRUCT	of;
	BOOL		fExist;

	GetMenuItem(g_qeglobals.d_lpMruMenu, wId, TRUE, szFileName, sizeof(szFileName));

	// Test if the file exists.
	fExist = OpenFile(szFileName, &of, OF_EXIST) != HFILE_ERROR;

	if (fExist)
	{
		// Place the file on the top of MRU
		AddNewItem(g_qeglobals.d_lpMruMenu, (LPSTR)szFileName);

		// Now perform opening this file !!!
		Map_LoadFile(szFileName);	
	}
	else
		// Remove the file on MRU.
		DelMenuItem(g_qeglobals.d_lpMruMenu, wId, TRUE);

	// Refresh the File menu.
	PlaceMenuMRUItem(g_qeglobals.d_lpMruMenu, GetSubMenu(GetMenu(hWnd), 0), ID_FILE_EXIT);

	return fExist;
}

// sikk---> Test Map
/*
==============
DoTestMap
=============
*/
void DoTestMap ()
{
	char	szWorkDir[MAX_PATH] = "";
	char	szParam[256] = "";
	char   *szMapName = &g_szCurrentMap[strlen(ValueForKey(g_qeglobals.d_entityProject, "mapspath"))];
	char	szBSPName[MAX_PATH] = "";
	int		handle;
	struct _finddata_t fileinfo;

	// strip "map" extension 
	strncpy(szBSPName, g_szCurrentMap, strlen(g_szCurrentMap) - 3);
	// append "bsp" extension
	strcat(szBSPName, "bsp");

	handle = _findfirst(szBSPName, &fileinfo);
	
	// if bsp file does not exist, return
	if (handle == -1)
	{
		MessageBox(g_qeglobals.d_hwndMain, "The respective BSP file does not exist.\nYou must build current map first", "QuakeEd 3: Error", MB_OK | MB_ICONEXCLAMATION);
		return;
	}


	if (g_qeglobals.d_savedinfo.bModName)
	{
		strcat(szParam, " -game ");
		strcat(szParam, g_qeglobals.d_savedinfo.szModName);
	}
	if (g_qeglobals.d_savedinfo.bHeapsize)
	{
		strcat(szParam, " -heapsize ");
		strcat(szParam, g_qeglobals.d_savedinfo.szHeapsize);
	}
	if (g_qeglobals.d_savedinfo.bSkill)
	{
		strcat(szParam, " +skill ");
		strcat(szParam, g_qeglobals.d_savedinfo.szSkill);
	}
	if (g_qeglobals.d_savedinfo.bDeathmatch)
		strcat(szParam, " +deathmatch 1");
	if (g_qeglobals.d_savedinfo.bDeveloper)
		strcat(szParam, " +developer 1");
	if (g_qeglobals.d_savedinfo.bRSpeeds)
		strcat(szParam, " +r_speeds 1");
	if (g_qeglobals.d_savedinfo.bPointfile)
		strcat(szParam, " +pointfile 1");

	strcat(szParam, " +map ");
	// strip file extension 
	strncat(szParam, szMapName, strlen(szMapName) - 4);	
	// strip executable file name for Working Directory
	strncpy(szWorkDir, g_qeglobals.d_savedinfo.szGamePath, 
		strlen(g_qeglobals.d_savedinfo.szGamePath) - 
		strlen(g_qeglobals.d_savedinfo.szGameName));

	Sys_Printf("======================================\nCMD: Testing map: %s...\n", szMapName);
	Sys_Printf("Parameters: %s\n", szParam);
	ShellExecute(NULL, "open", g_qeglobals.d_savedinfo.szGamePath, szParam, szWorkDir, SW_SHOW);
}
// <---sikk

/*
==============
CommandHandler

handle all WM_COMMAND messages here
==============
*/
LONG WINAPI CommandHandler (
	HWND	hWnd,
	WPARAM	wParam,
	LPARAM	lParam
	)
{
	HMENU hMenu = GetMenu(hWnd);
	int	nBandIndex;

	switch (LOWORD(wParam))
	{
//===================================
// file menu
//===================================
		case ID_FILE_NEW:
			if (!ConfirmModified())
				return TRUE;
			Map_New();
			break;
		case ID_FILE_OPEN:
			if (!ConfirmModified())
				return TRUE;
			OpenDialog();
			break;
		case ID_FILE_SAVE:
			if (!strcmp(g_szCurrentMap, "unnamed.map"))
				SaveAsDialog();
			else
				Map_SaveFile(g_szCurrentMap, false);	// ignore region
			break;
		case ID_FILE_SAVEAS:
			SaveAsDialog();
			break;

		case ID_FILE_NEWPROJECT:	// sikk - New Project Dialog
			NewProjectDialog();
			break;
		case ID_FILE_LOADPROJECT:
			if (!ConfirmModified())
				return TRUE;
			ProjectDialog();
			break;
		case ID_FILE_EDITPROJECT:	// sikk - Project Settings Dialog
			DoProject(false);
			break;

		case ID_FILE_IMPORTMAP:	// sikk - Import Map Dialog
			ImportDialog(true);
			break;
		case ID_FILE_IMPORTPREFAB:	// sikk - Import Prefab Dialog
			ImportDialog(false);
			break;

		case ID_FILE_POINTFILE:
			if (g_qeglobals.d_nPointfileDisplayList)
				Pointfile_Clear();
			else
				Pointfile_Check();
			break;

		case ID_FILE_PRINTXY:
			WXY_Print();
			break;

		case IDMRU + 1:
		case IDMRU + 2:
		case IDMRU + 3:
		case IDMRU + 4:
		case IDMRU + 5:
		case IDMRU + 6:
		case IDMRU + 7:
		case IDMRU + 8:
		case IDMRU + 9:
			DoMru(hWnd, LOWORD(wParam));
			break;

		case ID_FILE_EXIT:	// exit application
			if (!ConfirmModified())
				return TRUE;
			PostMessage(hWnd, WM_CLOSE, 0, 0L);
			break;

//===================================
// edit menu
//===================================
		case ID_EDIT_UNDO:	// sikk - Undo/Redo
			Undo_Undo();
			break;
		case ID_EDIT_REDO:	// sikk - Undo/Redo
			Undo_Redo();
			break;

// sikk---> TODO: Copy still broken
		case ID_EDIT_CUT:
			Undo_Start("Cut");
			Undo_AddBrushList(&g_brSelectedBrushes);
			Select_Cut();
			Undo_EndBrushList(&g_brSelectedBrushes);
			Undo_End();
			break;
		case ID_EDIT_COPY:
			Select_Copy();
			break;
		case ID_EDIT_PASTE:
			Undo_Start("Paste");
			Select_Paste();
			Undo_End();
			break;
// <---sikk

		case ID_EDIT_FINDBRUSH:
			DoFindBrush();
			break;

		case ID_EDIT_MAPINFO:	// sikk - Map Info Dialog
			DoMapInfo();
			break;
		case ID_EDIT_ENTITYINFO:	// sikk - Entity Info Dialog
			DoEntityInfo();
			break;

		case ID_EDIT_PREFERENCES:	// sikk - Preferences Dialog
			DoPreferences();
			break;

//===================================
// view menu
//===================================
// sikk---> Toolbar/Statusbar Toggle
		case ID_VIEW_TOOLBAR_FILEBAND:
			nBandIndex = SendMessage(g_qeglobals.d_hwndRebar, RB_IDTOINDEX, (WPARAM)ID_TOOLBAR + 0, (LPARAM)0);
			if (IsWindowVisible(g_qeglobals.d_hwndToolbar1))
				SendMessage(g_qeglobals.d_hwndRebar, RB_SHOWBAND, (WPARAM)nBandIndex, (LPARAM)FALSE);
			else
				SendMessage(g_qeglobals.d_hwndRebar, RB_SHOWBAND, (WPARAM)nBandIndex, (LPARAM)TRUE);
			break;
		case ID_VIEW_TOOLBAR_EDITBAND:
			nBandIndex = SendMessage(g_qeglobals.d_hwndRebar, RB_IDTOINDEX, (WPARAM)ID_TOOLBAR + 1, (LPARAM)0);
			if (IsWindowVisible(g_qeglobals.d_hwndToolbar2))
				SendMessage(g_qeglobals.d_hwndRebar, RB_SHOWBAND, (WPARAM)nBandIndex, (LPARAM)FALSE);
			else
				SendMessage(g_qeglobals.d_hwndRebar, RB_SHOWBAND, (WPARAM)nBandIndex, (LPARAM)TRUE);
			break;
		case ID_VIEW_TOOLBAR_EDIT2BAND:
			nBandIndex = SendMessage(g_qeglobals.d_hwndRebar, RB_IDTOINDEX, (WPARAM)ID_TOOLBAR + 2, (LPARAM)0);
			if (IsWindowVisible(g_qeglobals.d_hwndToolbar3))
				SendMessage(g_qeglobals.d_hwndRebar, RB_SHOWBAND, (WPARAM)nBandIndex, (LPARAM)FALSE);
			else
				SendMessage(g_qeglobals.d_hwndRebar, RB_SHOWBAND, (WPARAM)nBandIndex, (LPARAM)TRUE);
			break;
		case ID_VIEW_TOOLBAR_SELECTBAND:
			nBandIndex = SendMessage(g_qeglobals.d_hwndRebar, RB_IDTOINDEX, (WPARAM)ID_TOOLBAR + 3, (LPARAM)0);
			if (IsWindowVisible(g_qeglobals.d_hwndToolbar4))
				SendMessage(g_qeglobals.d_hwndRebar, RB_SHOWBAND, (WPARAM)nBandIndex, (LPARAM)FALSE);
			else
				SendMessage(g_qeglobals.d_hwndRebar, RB_SHOWBAND, (WPARAM)nBandIndex, (LPARAM)TRUE);
			break;
		case ID_VIEW_TOOLBAR_CSGBAND:
			nBandIndex = SendMessage(g_qeglobals.d_hwndRebar, RB_IDTOINDEX, (WPARAM)ID_TOOLBAR + 4, (LPARAM)0);
			if (IsWindowVisible(g_qeglobals.d_hwndToolbar5))
				SendMessage(g_qeglobals.d_hwndRebar, RB_SHOWBAND, (WPARAM)nBandIndex, (LPARAM)FALSE);
			else
				SendMessage(g_qeglobals.d_hwndRebar, RB_SHOWBAND, (WPARAM)nBandIndex, (LPARAM)TRUE);
			break;
		case ID_VIEW_TOOLBAR_MODEBAND:
			nBandIndex = SendMessage(g_qeglobals.d_hwndRebar, RB_IDTOINDEX, (WPARAM)ID_TOOLBAR + 5, (LPARAM)0);
			if (IsWindowVisible(g_qeglobals.d_hwndToolbar6))
				SendMessage(g_qeglobals.d_hwndRebar, RB_SHOWBAND, (WPARAM)nBandIndex, (LPARAM)FALSE);
			else
				SendMessage(g_qeglobals.d_hwndRebar, RB_SHOWBAND, (WPARAM)nBandIndex, (LPARAM)TRUE);
			break;
		case ID_VIEW_TOOLBAR_VIEWBAND:
			nBandIndex = SendMessage(g_qeglobals.d_hwndRebar, RB_IDTOINDEX, (WPARAM)ID_TOOLBAR + 6, (LPARAM)0);
			if (IsWindowVisible(g_qeglobals.d_hwndToolbar7))
				SendMessage(g_qeglobals.d_hwndRebar, RB_SHOWBAND, (WPARAM)nBandIndex, (LPARAM)FALSE);
			else
				SendMessage(g_qeglobals.d_hwndRebar, RB_SHOWBAND, (WPARAM)nBandIndex, (LPARAM)TRUE);
			break;
		case ID_VIEW_TOOLBAR_MISCBAND:
			nBandIndex = SendMessage(g_qeglobals.d_hwndRebar, RB_IDTOINDEX, (WPARAM)ID_TOOLBAR + 7, (LPARAM)0);
			if (IsWindowVisible(g_qeglobals.d_hwndToolbar8))
				SendMessage(g_qeglobals.d_hwndRebar, RB_SHOWBAND, (WPARAM)nBandIndex, (LPARAM)FALSE);
			else
				SendMessage(g_qeglobals.d_hwndRebar, RB_SHOWBAND, (WPARAM)nBandIndex, (LPARAM)TRUE);
			break;

		case ID_VIEW_STATUSBAR:
			if (IsWindowVisible(g_qeglobals.d_hwndStatus))
				DestroyWindow(g_qeglobals.d_hwndStatus);
			else
			{
				g_qeglobals.d_hwndStatus = CreateStatusBar(g_qeglobals.d_hwndMain);
				Sys_UpdateGridStatusBar();
				Sys_UpdateBrushStatusBar();
			}
			break;
// <---sikk

		case ID_VIEW_CAMERA:	// sikk - Toggle Camera View
			if (IsWindowVisible(g_qeglobals.d_hwndCamera))
			{
				if (GetTopWindow(hWnd) != g_qeglobals.d_hwndCamera)
					BringWindowToTop(g_qeglobals.d_hwndCamera);
				else
					ShowWindow(g_qeglobals.d_hwndCamera, SW_HIDE);
			}
			else
			{
				ShowWindow(g_qeglobals.d_hwndCamera, SW_SHOW);
				BringWindowToTop(g_qeglobals.d_hwndCamera);
			}
			break;
		
// sikk--->	quick hack for Show/Hide Entity Window
		case ID_VIEW_ENTITY:
			if (g_bShowEntity)
			{
				SetInspectorMode(W_ENTITY);
				g_bShowEntity = false;
				g_bShowConsole = true;
				g_bShowTexture = true;
			}
			else
			{	
				if (GetTopWindow(hWnd) != g_qeglobals.d_hwndEntity)
					BringWindowToTop(g_qeglobals.d_hwndEntity);
				else
				{
					ShowWindow(g_qeglobals.d_hwndEntity, SW_HIDE);
					g_bShowEntity = true;
					g_bShowConsole = true;
					g_bShowTexture = true;
				}
			}
			break;
		case ID_VIEW_CONSOLE:
			if (g_bShowConsole)
			{
				SetInspectorMode(W_CONSOLE);
				g_bShowConsole = false;
				g_bShowEntity = true;
				g_bShowTexture = true;
			}
			else
			{
				if (GetTopWindow(hWnd) != g_qeglobals.d_hwndEntity)
					BringWindowToTop(g_qeglobals.d_hwndEntity);
				else
				{
					ShowWindow(g_qeglobals.d_hwndEntity, SW_HIDE);
					g_bShowConsole = true;
					g_bShowEntity = true;
					g_bShowTexture = true;
				}
			}
			break;
		case ID_VIEW_TEXTURE:
			if (g_bShowTexture)
			{
				SetWindowText(g_qeglobals.d_hwndEntity, "Textures");
				SetInspectorMode(W_TEXTURE);
				g_bShowTexture = false;
				g_bShowEntity = true;
				g_bShowConsole = true;
			}
			else
			{				
				if (GetTopWindow(hWnd) != g_qeglobals.d_hwndEntity)
					BringWindowToTop(g_qeglobals.d_hwndEntity);
				else
				{
					ShowWindow(g_qeglobals.d_hwndEntity, SW_HIDE);
					g_bShowTexture = true;
					g_bShowEntity = true;
					g_bShowConsole = true;
				}
			}
			break;
// <---sikk

		case ID_VIEW_CENTER:
			g_qeglobals.d_camera.angles[ROLL] = g_qeglobals.d_camera.angles[PITCH] = 0;
			g_qeglobals.d_camera.angles[YAW] = 22.5f * floor((g_qeglobals.d_camera.angles[YAW] + 11) / 22.5f);
			Sys_UpdateWindows(W_CAMERA|W_XY_OVERLAY);
			break;
		case ID_VIEW_UPFLOOR:
			Cam_ChangeFloor(true);
			break;
		case ID_VIEW_DOWNFLOOR:
			Cam_ChangeFloor(false);
			break;

		case ID_VIEW_CENTERONSELECTION:	// sikk - Center Views on Selection
			XY_PositionView();
			Cam_PositionView();
			Sys_UpdateWindows(W_ALL);
			break;

		case ID_VIEW_NEXTVIEW:
			if (g_qeglobals.d_nViewType == XY)
			{
				g_qeglobals.d_nViewType = XZ;
				SetWindowText(g_qeglobals.d_hwndXY, "XZ View: Front");
			}
			else if (g_qeglobals.d_nViewType == XZ)
			{
				g_qeglobals.d_nViewType = YZ;
				SetWindowText(g_qeglobals.d_hwndXY, "YZ View: Side");
			}
			else
			{
				g_qeglobals.d_nViewType = XY;
				SetWindowText(g_qeglobals.d_hwndXY, "XY View: Top");
			}
			XY_PositionView();
			Sys_UpdateWindows(W_XY | W_XY_OVERLAY | W_CAMERA);
			break;
		case ID_VIEW_XY:
			g_qeglobals.d_nViewType = XY;
			SetWindowText(g_qeglobals.d_hwndXY, "XY Top");
			XY_PositionView();
			Sys_UpdateWindows(W_XY | W_XY_OVERLAY | W_CAMERA);
			break;
		case ID_VIEW_FRONT:
			g_qeglobals.d_nViewType = XZ;
			SetWindowText(g_qeglobals.d_hwndXY, "XZ Front");
			XY_PositionView();
			Sys_UpdateWindows(W_XY | W_XY_OVERLAY | W_CAMERA);
			break;
		case ID_VIEW_SIDE:
			g_qeglobals.d_nViewType = YZ;
			SetWindowText(g_qeglobals.d_hwndXY, "YZ Side");
			XY_PositionView();
			Sys_UpdateWindows(W_XY | W_XY_OVERLAY | W_CAMERA);
			break;

		case ID_VIEW_100:
			g_qeglobals.d_xyz.scale = 1;
			Sys_UpdateWindows(W_XY | W_XY_OVERLAY);
			break;
		case ID_VIEW_ZOOMIN:
			g_qeglobals.d_xyz.scale *= 5.0 / 4;
			if (g_qeglobals.d_xyz.scale > 32)
				g_qeglobals.d_xyz.scale = 32;
			Sys_UpdateWindows(W_XY | W_XY_OVERLAY);
			break;
		case ID_VIEW_ZOOMOUT:
			g_qeglobals.d_xyz.scale *= 4.0f / 5;
			if (g_qeglobals.d_xyz.scale < 0.05)
				g_qeglobals.d_xyz.scale = 0.05f;
			Sys_UpdateWindows(W_XY | W_XY_OVERLAY);
			break;

		case ID_VIEW_Z100:
			g_qeglobals.d_z.scale = 1;
			Sys_UpdateWindows(W_Z | W_Z_OVERLAY);
			break;
		case ID_VIEW_ZZOOMIN:
			g_qeglobals.d_z.scale *= 5.0 / 4;
			if (g_qeglobals.d_z.scale > 16)
				g_qeglobals.d_z.scale = 16;
			Sys_UpdateWindows(W_Z | W_Z_OVERLAY);
			break;
		case ID_VIEW_ZZOOMOUT:
			g_qeglobals.d_z.scale *= 4.0f / 5;
			if (g_qeglobals.d_z.scale < 0.1)
				g_qeglobals.d_z.scale = 0.1f;
			Sys_UpdateWindows(W_Z | W_Z_OVERLAY);
			break;

		case ID_VIEW_CAMSPEED:	// sikk - Camera Speed Trackbar in toolbar
			DoCamSpeed();
			break;

// sikk---> Cubic Clipping
		case ID_VIEW_CUBICCLIP:
			g_qeglobals.d_savedinfo.bCubicClip ^= true;
			Sys_UpdateWindows(W_XY | W_CAMERA);
			break;
		case ID_VIEW_CUBICCLIPZOOMIN:
			g_qeglobals.d_savedinfo.nCubicScale--;
			if (g_qeglobals.d_savedinfo.nCubicScale < 1)
				g_qeglobals.d_savedinfo.nCubicScale = 1;
			Sys_UpdateGridStatusBar();
			Sys_UpdateWindows(W_CAMERA);
			break;

		case ID_VIEW_CUBICCLIPZOOMOUT:
			g_qeglobals.d_savedinfo.nCubicScale++;
			if (g_qeglobals.d_savedinfo.nCubicScale > 64)
				g_qeglobals.d_savedinfo.nCubicScale = 64;
			Sys_UpdateGridStatusBar();
			Sys_UpdateWindows(W_CAMERA);
			break;
// <---sikk

		case ID_VIEW_SHOWAXIS:	// sikk - Show Axis
			g_qeglobals.d_savedinfo.bShow_Axis ^= true;
			Sys_UpdateWindows(W_XY | W_CAMERA);
			break;
		case ID_VIEW_SHOWBLOCKS:
			g_qeglobals.d_savedinfo.bShow_Blocks ^= true;
			Sys_UpdateWindows(W_XY);
			break;
		case ID_VIEW_SHOWCAMERAGRID:	// sikk - Camera Grid
			g_qeglobals.d_savedinfo.bShow_CameraGrid ^= true;
			Sys_UpdateWindows(W_CAMERA);
			break;
		case ID_VIEW_SHOWCOORDINATES:
			g_qeglobals.d_savedinfo.bShow_Coordinates ^= true;
			Sys_UpdateWindows(W_XY | W_Z);
			break;
		case ID_VIEW_SHOWLIGHTRADIUS:	// sikk - Show Light Radius
			g_qeglobals.d_savedinfo.bShow_LightRadius ^= true;
			Sys_UpdateWindows(W_XY);
			break;
		case ID_VIEW_SHOWMAPBOUNDRY:	// sikk - Show Map Boundry Box
			g_qeglobals.d_savedinfo.bShow_MapBoundry ^= true;
			Sys_UpdateWindows(W_CAMERA);
			break;
		case ID_VIEW_SHOWNAMES:
			g_qeglobals.d_savedinfo.bShow_Names ^= true;
			Map_BuildBrushData();
			Sys_UpdateWindows(W_XY);
			break;
		case ID_VIEW_SHOWSIZEINFO:
			g_qeglobals.d_savedinfo.bShow_SizeInfo ^= true;
			Map_BuildBrushData();
			Sys_UpdateWindows(W_XY);
			break;
		case ID_VIEW_SHOWVIEWNAME:
			g_qeglobals.d_savedinfo.bShow_Viewname ^= true;
			Sys_UpdateWindows(W_XY);
			break;
		case ID_VIEW_SHOWWORKZONE:
			g_qeglobals.d_savedinfo.bShow_Workzone ^= true;
			Sys_UpdateWindows(W_XY);
			break;

		case ID_VIEW_SHOWANGLES:
			g_qeglobals.d_savedinfo.nExclude ^= EXCLUDE_ANGLES;
			Sys_UpdateWindows(W_XY | W_CAMERA);
			break;
		case ID_VIEW_SHOWCLIP:
			g_qeglobals.d_savedinfo.nExclude ^= EXCLUDE_CLIP;
			Sys_UpdateWindows(W_XY | W_CAMERA);
			break;
		case ID_VIEW_SHOWENT:
			g_qeglobals.d_savedinfo.nExclude ^= EXCLUDE_ENT;
			Sys_UpdateWindows(W_XY | W_CAMERA);
			break;
		case ID_VIEW_SHOWFUNCWALL:
			g_qeglobals.d_savedinfo.nExclude ^= EXCLUDE_FUNC_WALL;
			Sys_UpdateWindows(W_XY | W_CAMERA);
			break;
		case ID_VIEW_SHOWLIGHTS:
			g_qeglobals.d_savedinfo.nExclude ^= EXCLUDE_LIGHTS;
			Sys_UpdateWindows(W_XY | W_CAMERA);
			break;
		case ID_VIEW_SHOWPATH:
			g_qeglobals.d_savedinfo.nExclude ^= EXCLUDE_PATHS;
			Sys_UpdateWindows(W_XY | W_CAMERA);
			break;
		case ID_VIEW_SHOWSKY:
			g_qeglobals.d_savedinfo.nExclude ^= EXCLUDE_SKY;
			Sys_UpdateWindows(W_XY | W_CAMERA);
			break;
		case ID_VIEW_SHOWWATER:
			g_qeglobals.d_savedinfo.nExclude ^= EXCLUDE_WATER;
			Sys_UpdateWindows(W_XY | W_CAMERA);
			break;
		case ID_VIEW_SHOWWORLD:
			g_qeglobals.d_savedinfo.nExclude ^= EXCLUDE_WORLD;
			Sys_UpdateWindows(W_XY | W_CAMERA);
			break;

		case ID_VIEW_HIDESHOW_HIDESELECTED:
			Select_Hide();
			Select_Deselect(true);
			break;
		case ID_VIEW_HIDESHOW_SHOWHIDDEN:
			Select_ShowAllHidden();
			break;

//===================================
// select menu
//===================================
		case ID_SELECTION_DRAGEDGES:
			if (g_qeglobals.d_selSelectMode == sel_edge)
			{
				g_qeglobals.d_selSelectMode = sel_brush;
				Sys_UpdateWindows(W_ALL);
			}
			else
			{
				SetupVertexSelection();
				if (g_qeglobals.d_nNumPoints)
					g_qeglobals.d_selSelectMode = sel_edge;
			}
			break;
		case ID_SELECTION_DRAGVERTICES:
			if (g_qeglobals.d_selSelectMode == sel_vertex)
			{
				g_qeglobals.d_selSelectMode = sel_brush;
				Sys_UpdateWindows(W_ALL);
			}
			else
			{
				SetupVertexSelection();
				if (g_qeglobals.d_nNumPoints)
					g_qeglobals.d_selSelectMode = sel_vertex;
			}
			break;

		case ID_SELECTION_CLONE:
			Undo_Start("Clone");
//			Undo_AddBrushList(&g_brSelectedBrushes);
			Select_Clone();
//			Undo_EndBrushList(&g_brSelectedBrushes);
			Undo_End();
			break;
		case ID_SELECTION_DESELECT:
			if (g_qeglobals.d_bClipMode)
				Clip_UnsetMode();
			else
				Select_Deselect(true);
			break;
		case ID_SELECTION_INVERT:
			Select_Invert();
			break;
		case ID_SELECTION_DELETE:
			{	// sikk - TODO: Undo doesn't function properly with mixed selection  
				brush_t *brush;

				Undo_Start("Delete");
				Undo_AddBrushList(&g_brSelectedBrushes);
				// add all deleted entities to the undo
				for (brush = g_brSelectedBrushes.next; brush != &g_brSelectedBrushes; brush = brush->next)
					Undo_AddEntity(brush->owner);
				Select_Delete();
				Undo_EndBrushList(&g_brSelectedBrushes);
				Undo_End();
			}
			break;

		case ID_SELECTION_FLIPX:
			Undo_Start("Flip X");
			Undo_AddBrushList(&g_brSelectedBrushes);
			Select_FlipAxis(0);
			Undo_EndBrushList(&g_brSelectedBrushes);
			Undo_End();
			break;
		case ID_SELECTION_FLIPY:
			Undo_Start("Flip Y");
			Undo_AddBrushList(&g_brSelectedBrushes);
			Select_FlipAxis(1);
			Undo_EndBrushList(&g_brSelectedBrushes);
			Undo_End();
			break;
		case ID_SELECTION_FLIPZ:
			Undo_Start("Flip Z");
			Undo_AddBrushList(&g_brSelectedBrushes);
			Select_FlipAxis(2);
			Undo_EndBrushList(&g_brSelectedBrushes);
			Undo_End();
			break;

		case ID_SELECTION_ROTATEX:
			Undo_Start("Rotate X");
			Undo_AddBrushList(&g_brSelectedBrushes);
			Select_RotateAxis(0, 90, false);
			Undo_EndBrushList(&g_brSelectedBrushes);
			Undo_End();
			break;
		case ID_SELECTION_ROTATEY:
			Undo_Start("Rotate X");
			Undo_AddBrushList(&g_brSelectedBrushes);
			Select_RotateAxis(1, 90, false);
			Undo_EndBrushList(&g_brSelectedBrushes);
			Undo_End();
			break;
		case ID_SELECTION_ROTATEZ:
			Undo_Start("Rotate X");
			Undo_AddBrushList(&g_brSelectedBrushes);
			Select_RotateAxis(2, 90, false);
			Undo_EndBrushList(&g_brSelectedBrushes);
			Undo_End();
			break;
		case ID_SELECTION_ARBITRARYROTATION:
			Undo_Start("Arbitrary Rotation");
			Undo_AddBrushList(&g_brSelectedBrushes);
			DoRotate();
			Undo_EndBrushList(&g_brSelectedBrushes);
			Undo_End();
			break;

		case ID_SELECTION_SCALELOCKX:	// sikk - Brush Scaling Axis Lock
			g_qeglobals.d_savedinfo.bScaleLockX ^= true;
			Sys_UpdateWindows(W_XY | W_Z | W_CAMERA);
			break;
		case ID_SELECTION_SCALELOCKY:	// sikk - Brush Scaling Axis Lock
			g_qeglobals.d_savedinfo.bScaleLockY ^= true;
			Sys_UpdateWindows(W_XY | W_Z | W_CAMERA);
			break;
		case ID_SELECTION_SCALELOCKZ:	// sikk - Brush Scaling Axis Lock
			g_qeglobals.d_savedinfo.bScaleLockZ ^= true;
			Sys_UpdateWindows(W_XY | W_Z | W_CAMERA);
			break;
		case ID_SELECTION_SCALE:	// sikk - Brush Scaling Dialog
			Undo_Start("Scale");
			Undo_AddBrushList(&g_brSelectedBrushes);
			DoScale();
			Undo_EndBrushList(&g_brSelectedBrushes);
			Undo_End();
			break;

		case ID_SELECTION_CSGHOLLOW:
			Undo_Start("CSG Hollow");
			Undo_AddBrushList(&g_brSelectedBrushes);
			CSG_Hollow();
			Undo_EndBrushList(&g_brSelectedBrushes);
			Undo_End();
			break;
		case ID_SELECTION_CSGSUBTRACT:
			Undo_Start("CSG Subtract");
			CSG_Subtract();
			Undo_End();
			break;
		case ID_SELECTION_CSGMERGE:
			Undo_Start("CSG Merge");
			Undo_AddBrushList(&g_brSelectedBrushes);
			CSG_Merge();
			Undo_EndBrushList(&g_brSelectedBrushes);
			Undo_End();
			break;

		case ID_SELECTION_CLIPPER:
			Clip_SetMode();
			break;
		case ID_SELECTION_CLIPSELECTED:
			Undo_Start("Clip Selected");
			Undo_AddBrushList(&g_brSelectedBrushes);
			Clip_Clip();
			Undo_EndBrushList(&g_brSelectedBrushes);
			Undo_End();
			break;
		case ID_SELECTION_SPLITSELECTED:
			Undo_Start("Split Selected");
			Undo_AddBrushList(&g_brSelectedBrushes);
			Clip_Split();
			Undo_EndBrushList(&g_brSelectedBrushes);
			Undo_End();
			break;
		case ID_SELECTION_FLIPCLIP:
			Clip_Flip();
			break;

		case ID_SELECTION_SELECTCOMPLETETALL:
			Select_CompleteTall();
			break;
		case ID_SELECTION_SELECTTOUCHING:
			Select_Touching();
			break;
		case ID_SELECTION_SELECTPARTIALTALL:
			Select_PartialTall();
			break;
		case ID_SELECTION_SELECTINSIDE:
			Select_Inside();
			break;
		case ID_SELECTION_SELECTALL:	// sikk - Select All
			Select_All();
			break;
		case ID_SELECTION_SELECTALLTYPE:	// sikk - Select All Type
			Select_AllType();
			break;

		case ID_SELECTION_SELECTMATCHINGTEXTURES:	// sikk - Select Matching Textures
			Select_MatchingTextures();
			break;

		case ID_SELECTION_CONNECT:
			Select_ConnectEntities();
			break;
		case ID_SELECTION_UNGROUPENTITY:
			Select_Ungroup();
			break;
		case ID_SELECTION_GROUPNEXTBRUSH:
			Select_NextBrushInGroup();
			break;

		case ID_SELECTION_EXPORTMAP:	// sikk - Export Selection Dialog (Map format)
			ExportDialog(true);
			break;
		case ID_SELECTION_EXPORTPREFAB:	// sikk - Export Selection Dialog (Prefab format)
			ExportDialog(false);
			break;

//===================================
// bsp menu
//===================================
		case CMD_BSPCOMMAND:
		case CMD_BSPCOMMAND + 1:
		case CMD_BSPCOMMAND + 2:
		case CMD_BSPCOMMAND + 3:
		case CMD_BSPCOMMAND + 4:
		case CMD_BSPCOMMAND + 5:
		case CMD_BSPCOMMAND + 6:
		case CMD_BSPCOMMAND + 7:
		case CMD_BSPCOMMAND + 8:
		case CMD_BSPCOMMAND + 9:
		case CMD_BSPCOMMAND + 10:
		case CMD_BSPCOMMAND + 11:
		case CMD_BSPCOMMAND + 12:
		case CMD_BSPCOMMAND + 13:
		case CMD_BSPCOMMAND + 14:
		case CMD_BSPCOMMAND + 15:
		case CMD_BSPCOMMAND + 16:
		case CMD_BSPCOMMAND + 17:
		case CMD_BSPCOMMAND + 18:
		case CMD_BSPCOMMAND + 19:
		case CMD_BSPCOMMAND + 20:
		case CMD_BSPCOMMAND + 21:
		case CMD_BSPCOMMAND + 22:
		case CMD_BSPCOMMAND + 23:
		case CMD_BSPCOMMAND + 24:
		case CMD_BSPCOMMAND + 25:
		case CMD_BSPCOMMAND + 26:
		case CMD_BSPCOMMAND + 27:
		case CMD_BSPCOMMAND + 28:
		case CMD_BSPCOMMAND + 29:
		case CMD_BSPCOMMAND + 30:
		case CMD_BSPCOMMAND + 31:
			RunBsp(g_szBSP_Commands[LOWORD(wParam - CMD_BSPCOMMAND)]);
			break;

//===================================
// grid menu
//===================================
		case ID_GRID_1:
		case ID_GRID_2:
		case ID_GRID_4:
		case ID_GRID_8:
		case ID_GRID_16:
		case ID_GRID_32:
		case ID_GRID_64:
		case ID_GRID_128:
		case ID_GRID_256:
			CheckMenuItem(hMenu, ID_GRID_1, MF_UNCHECKED);
			CheckMenuItem(hMenu, ID_GRID_2, MF_UNCHECKED);
			CheckMenuItem(hMenu, ID_GRID_4, MF_UNCHECKED);
			CheckMenuItem(hMenu, ID_GRID_8, MF_UNCHECKED);
			CheckMenuItem(hMenu, ID_GRID_16, MF_UNCHECKED);
			CheckMenuItem(hMenu, ID_GRID_32, MF_UNCHECKED);
			CheckMenuItem(hMenu, ID_GRID_64, MF_UNCHECKED);
			CheckMenuItem(hMenu, ID_GRID_128, MF_UNCHECKED);
			CheckMenuItem(hMenu, ID_GRID_256, MF_UNCHECKED);

			switch (LOWORD(wParam))
			{
				case ID_GRID_1:		g_qeglobals.d_nGridSize = 1;	break;
				case ID_GRID_2:		g_qeglobals.d_nGridSize = 2;	break;
				case ID_GRID_4:		g_qeglobals.d_nGridSize = 4;	break;
				case ID_GRID_8:		g_qeglobals.d_nGridSize = 8;	break;
				case ID_GRID_16:	g_qeglobals.d_nGridSize = 16;	break;
				case ID_GRID_32:	g_qeglobals.d_nGridSize = 32;	break;
				case ID_GRID_64:	g_qeglobals.d_nGridSize = 64;	break;
				case ID_GRID_128:	g_qeglobals.d_nGridSize = 128;	break;
				case ID_GRID_256:	g_qeglobals.d_nGridSize = 256;	break;
			}

			CheckMenuItem(hMenu, LOWORD(wParam), MF_CHECKED);
			Sys_UpdateWindows(W_XY | W_Z);
			Sys_UpdateGridStatusBar();
			break;

		case ID_GRID_TOGGLE:	// sikk - Gridd Toggle
			g_qeglobals.d_bShowGrid ^= true;
			PostMessage(g_qeglobals.d_hwndXY, WM_PAINT, 0, 0);
			Sys_UpdateWindows(W_Z | W_XY);
			break;

		case ID_GRID_SNAPTOGRID:
			g_qeglobals.d_savedinfo.bNoClamp ^= true;
			Sys_UpdateGridStatusBar();
			break;

//===================================
// texture menu
//===================================
		case ID_TEXTURES_UPDATEMENU:
			Sys_BeginWait();
			FillTextureMenu();
			SetInspectorMode(W_CONSOLE);
			break;

		case ID_TEXTURES_FLUSH_ALL:
			Sys_BeginWait();
//			Map_New();	// sikk - I don't understand the point to start a new map. 
						// We want to flush all textures, not flush everything I've
						// done to this point and forgot to save.
			Texture_Flush();
			Texture_Init();
			SetInspectorMode(W_TEXTURE);
			Sys_UpdateWindows(W_TEXTURE);
			SetWindowText(g_qeglobals.d_hwndEntity, "Flushed All...");
			break;
		case ID_TEXTURES_FLUSH_UNUSED:
			Sys_BeginWait();
			Texture_ShowInuse();
			Texture_FlushUnused();
			SetInspectorMode(W_TEXTURE);
			Sys_UpdateWindows(W_TEXTURE);
			SetWindowText(g_qeglobals.d_hwndEntity, "Flushed Unused...");
			break;
		// sikk - TODO: This doesn't function like Radiant and is, for
		// the most part, pointless. Will later make it toggle along 
		// with a "Show All" command .
		case ID_TEXTURES_SHOWINUSE:
			Sys_BeginWait();
			Texture_ShowInuse();
			SetInspectorMode(W_TEXTURE);
			break;

		case ID_TEXTURES_RESETSCALE:	// sikk - Reset Texture View Scale
			g_qeglobals.d_texturewin.scale = 1;
			Sys_UpdateWindows(W_TEXTURE);
			break;

		case ID_TEXTURES_REPLACEALL:
			DoFindTexture();
			break;
		case ID_TEXTURES_LOCK:
			g_qeglobals.d_bTextureLock ^= true;
			Sys_UpdateWindows(W_CAMERA);
			Sys_UpdateGridStatusBar();
			break;

		case ID_TEXTURES_INSPECTOR:
			DoSurface();
			break;

		case ID_TEXTURES_POPUP:	// sikk - Toolbar Button
			DoTexturesPopup();
			break;

		case ID_TEXTURES_WIREFRAME:
		case ID_TEXTURES_FLATSHADE:
		case ID_TEXTURES_NEAREST:
		case ID_TEXTURES_NEARESTMIPMAP:
		case ID_TEXTURES_LINEAR:
		case ID_TEXTURES_BILINEAR:
		case ID_TEXTURES_BILINEARMIPMAP:
		case ID_TEXTURES_TRILINEAR:
			Texture_SetMode(LOWORD(wParam));
			break;

		case CMD_TEXTUREWAD:
		case CMD_TEXTUREWAD + 1:
		case CMD_TEXTUREWAD + 2:
		case CMD_TEXTUREWAD + 3:
		case CMD_TEXTUREWAD + 4:
		case CMD_TEXTUREWAD + 5:
		case CMD_TEXTUREWAD + 6:
		case CMD_TEXTUREWAD + 7:
		case CMD_TEXTUREWAD + 8:
		case CMD_TEXTUREWAD + 9:
		case CMD_TEXTUREWAD + 10:
		case CMD_TEXTUREWAD + 11:
		case CMD_TEXTUREWAD + 12:
		case CMD_TEXTUREWAD + 13:
		case CMD_TEXTUREWAD + 14:
		case CMD_TEXTUREWAD + 15:
		case CMD_TEXTUREWAD + 16:
		case CMD_TEXTUREWAD + 17:
		case CMD_TEXTUREWAD + 18:
		case CMD_TEXTUREWAD + 19:
		case CMD_TEXTUREWAD + 20:
		case CMD_TEXTUREWAD + 21:
		case CMD_TEXTUREWAD + 22:
		case CMD_TEXTUREWAD + 23:
		case CMD_TEXTUREWAD + 24:
		case CMD_TEXTUREWAD + 25:
		case CMD_TEXTUREWAD + 26:
		case CMD_TEXTUREWAD + 27:
		case CMD_TEXTUREWAD + 28:
		case CMD_TEXTUREWAD + 29:
		case CMD_TEXTUREWAD + 30:
		case CMD_TEXTUREWAD + 31:
			Sys_BeginWait();
			Texture_ShowWad(LOWORD(wParam));
			SetInspectorMode(W_TEXTURE);
			break;

//===================================
// misc menu
//===================================
		case ID_MISC_BENCHMARK:
			SendMessage(g_qeglobals.d_hwndCamera, WM_USER + 267, 0, 0);
			SetInspectorMode(W_CONSOLE);
			break;

// sikk---> Color Themes
// I will continue to add themes as I am able to get the colors used by other popular 3D apps
//								{COLOR_BRUSHES},	{COLOR_CAMERABACK},	   {COLOR_CAMERAGRID}, {COLOR_GRIDBACK},   {COLOR_GRIDBLOCK},
//								{COLOR_GRIDMAJOR},	{COLOR_GRIDMINOR},	   {COLOR_GRIDTEXT},   {COLOR_MAPBOUNDRY}, {COLOR_VIEWNAME}
		case ID_THEMES_QE4:
			{
				vec3_t v[] = {	{0.0f, 0.0f, 0.0f}, {0.25f, 0.25f, 0.25f}, {0.2f, 0.2f, 0.2f}, {1.0f, 1.0f, 1.0f}, {0.0f, 0.0f, 1.0f},
								{0.5f, 0.5f, 0.5f}, {0.75f, 0.75f, 0.75f}, {0.0f, 0.0f, 0.0f}, {0.0f, 0.0f, 0.0f}, {0.5f, 0.0f, 0.75f}	};
				DoTheme(v);
			}
			break;
		case ID_THEMES_Q3RADIANT:
			{
				vec3_t v[] = {	{0.0f, 0.0f, 0.0f}, {0.25f, 0.25f, 0.25f}, {0.2f, 0.2f, 0.2f}, {1.0f, 1.0f, 1.0f}, {0.0f, 0.0f, 1.0f},
								{0.5f, 0.5f, 0.5f}, {1.0f,  1.0f,  1.0f},  {0.0f, 0.0f, 0.0f}, {0.0f, 0.0f, 0.0f}, {0.5f, 0.0f, 0.75f}	};
				DoTheme(v);
			}
			break;
		case ID_THEMES_BLACKGREEN:
			{
				vec3_t v[] = {	{1.0f, 1.0f, 1.0f}, {0.25f, 0.25f, 0.25f}, {0.2f, 0.2f, 0.2f}, {0.0f, 0.0f, 0.0f}, {0.0f, 0.0f, 1.0f},
								{0.3f, 0.5f, 0.5f}, {0.0f,  0.0f,  0.0f},  {1.0f, 1.0f, 1.0f}, {0.0f, 0.0f, 0.0f}, {0.7f, 0.7f, 0.0f}	};
				DoTheme(v);
			}
			break;
		case ID_THEMES_WORLDCRAFT:
			{
				vec3_t v[] = {	{1.0f,  1.0f,  1.0f},  {0.0f, 0.0f, 0.0f}, {0.2f, 0.2f, 0.2f}, {0.0f,  0.0f,  0.0f},  {0.0f, 0.5f, 0.5f},
								{0.35f, 0.35f, 0.35f}, {0.2f, 0.2f, 0.2f}, {1.0f, 1.0f, 1.0f}, {0.25f, 0.25f, 0.25f}, {0.7f, 0.7f, 0.0f}	};
				DoTheme(v);
			}
			break;
		case ID_THEMES_UNREALED:
			{
				vec3_t v[] = {	{0.0f,  0.0f,  0.0f},  {0.0f,  0.0f,  0.0f},  {0.0f, 0.0f, 0.5f}, {0.64f, 0.64f, 0.64f}, {0.25f, 0.25f, 0.25f},
								{0.47f, 0.47f, 0.47f}, {0.58f, 0.58f, 0.58f}, {0.0f, 0.0f, 0.0f}, {0.0f,  0.0f,  0.5f},  {0.5f,  0.0f,  0.75f}	};
				DoTheme(v);
			}
			break;
		case ID_THEMES_BLENDER:
			{
				vec3_t v[] = {	{0.0f,  0.0f,  0.0f},  {0.25f, 0.25f, 0.25f}, {0.2f, 0.2f, 0.2f}, {0.45f, 0.45f, 0.45f}, {0.25f, 0.25f, 0.25f},
								{0.36f, 0.36f, 0.36f}, {0.4f,  0.4f,  0.4f},  {1.0f, 1.0f, 1.0f}, {0.2f,  0.2f,  0.2f},  {0.5f,  0.0f,  0.0f}	};
				DoTheme(v);
			}
			break;
		case ID_THEMES_MAYA:
			{
				vec3_t v[] = {	{0.0f,  0.0f,  0.0f},  {0.57f, 0.57f, 0.57f}, {0.47f, 0.47f, 0.47f}, {0.64f, 0.64f, 0.64f}, {0.25f, 0.25f, 0.25f},
								{0.47f, 0.47f, 0.47f}, {0.58f, 0.58f, 0.58f}, {0.0f,  0.0f,  0.0f},  {0.2f,  0.2f,  0.2f},  {0.0f,  0.45f, 0.0f}	};
				DoTheme(v);
			}
			break;
		case ID_THEMES_LIGHTWAVE:
			{
				vec3_t v[] = {	{0.0f,  0.0f,  0.0f},  {0.42f, 0.42f, 0.42f}, {0.56f, 0.56f, 0.56f}, {0.42f, 0.42f, 0.42f}, {0.25f, 0.25f, 0.25f},
								{0.56f, 0.56f, 0.56f}, {0.48f, 0.48f, 0.48f}, {0.75f, 0.75f, 0.75f}, {0.32f, 0.32f, 0.32f}, {0.0f,  0.75f, 0.75f}	};
				DoTheme(v);
			}
			break;
		case ID_THEMES_3DSMAX:
			{
				vec3_t v[] = {	{0.0f,  0.0f,  0.0f},  {0.48f, 0.48f, 0.48f}, {0.36f, 0.36f, 0.36f}, {0.48f, 0.48f, 0.48f}, {0.25f, 0.25f, 0.25f},
								{0.36f, 0.36f, 0.36f}, {0.42f, 0.42f, 0.42f}, {0.0f,  0.0f, 0.0f},  {0.2f,  0.2f,  0.2f},  {0.75f,  0.75f, 0.75f}	};
				DoTheme(v);
			}
			break;
// <---sikk
			
		case ID_COLORS_VIEWNAME:
			DoColor(COLOR_VIEWNAME);
			Sys_UpdateWindows(W_ALL);
			break;
		case ID_COLORS_CAMERABACK:
			DoColor(COLOR_CAMERABACK);
			Sys_UpdateWindows(W_ALL);
			break;
		case ID_COLORS_CAMERAGRID:
			DoColor(COLOR_CAMERAGRID);
			Sys_UpdateWindows(W_ALL);
			break;
		case ID_COLORS_CLIPPER:
			DoColor(COLOR_CLIPPER);
			Sys_UpdateWindows(W_ALL);
			break;
		case ID_COLORS_BRUSHES:
			DoColor(COLOR_BRUSHES);
			Sys_UpdateWindows(W_ALL);
			break;
		case ID_COLORS_GRIDBACK:
			DoColor(COLOR_GRIDBACK);
			Sys_UpdateWindows(W_ALL);
			break;
		case ID_COLORS_GRIDBLOCK:
			DoColor(COLOR_GRIDBLOCK);
			Sys_UpdateWindows(W_ALL);
			break;
		case ID_COLORS_GRIDMAJOR:
			DoColor(COLOR_GRIDMAJOR);
			Sys_UpdateWindows(W_ALL);
			break;
		case ID_COLORS_GRIDMINOR:
			DoColor(COLOR_GRIDMINOR);
			Sys_UpdateWindows(W_ALL);
			break;
		case ID_COLORS_GRIDTEXT:
			DoColor(COLOR_GRIDTEXT);
			Sys_UpdateWindows(W_ALL);
			break;
		case ID_COLORS_MAPBOUNDRY:
			DoColor(COLOR_MAPBOUNDRY);
			Sys_UpdateWindows(W_ALL);
			break;
		case ID_COLORS_SELECTEDBRUSH:
			DoColor(COLOR_SELBRUSHES);
			Sys_UpdateWindows(W_ALL);
			break;
		case ID_COLORS_TEXTUREBACK:
			DoColor(COLOR_TEXTUREBACK);
			Sys_UpdateWindows(W_ALL);
			break;
		case ID_COLORS_TEXTURETEXT:
			DoColor(COLOR_TEXTURETEXT);
			Sys_UpdateWindows(W_ALL);
			break;

		case ID_MISC_NEXTLEAKSPOT:
			Pointfile_Next();
			break;
		case ID_MISC_PREVIOUSLEAKSPOT:
			Pointfile_Prev();
			break;

		case ID_MISC_SELECTENTITYCOLOR:
			if ((g_qeglobals.d_nInspectorMode == W_ENTITY) && DoColor(COLOR_ENTITY) == true)
			{
				char buffer[64];
				
				sprintf(buffer, "%f %f %f", g_qeglobals.d_savedinfo.v3Colors[COLOR_ENTITY][0],
											g_qeglobals.d_savedinfo.v3Colors[COLOR_ENTITY][1],
											g_qeglobals.d_savedinfo.v3Colors[COLOR_ENTITY][2]);
				
				SetWindowText(g_hwndEnt[ENT_KEYFIELD], "_color");
				SetWindowText(g_hwndEnt[ENT_VALUEFIELD], buffer);
				AddProp();
			}
			Sys_UpdateWindows(W_ALL);
			break;

		case ID_MISC_TESTMAP:
			DoTestMap();
			break;

//===================================
// region menu
//===================================
		case ID_REGION_OFF:
			Map_RegionOff();
			break;

		case ID_REGION_SETXY:
			Map_RegionXY();
			break;
		case ID_REGION_SETTALLBRUSH:
			Map_RegionTallBrush();
			break;
		case ID_REGION_SETBRUSH:
			Map_RegionBrush();
			break;
		case ID_REGION_SETSELECTION:
			Map_RegionSelectedBrushes();
			break;

//===================================
// brush menu
//===================================
		case ID_BRUSH_3SIDED:
			Undo_Start("3 Sided");
			Undo_AddBrushList(&g_brSelectedBrushes);
			Brush_MakeSided(3);
			Undo_EndBrushList(&g_brSelectedBrushes);
			Undo_End();
			break;
		case ID_BRUSH_4SIDED:
			Undo_Start("4 Sided");
			Undo_AddBrushList(&g_brSelectedBrushes);
			Brush_MakeSided(4);
			Undo_EndBrushList(&g_brSelectedBrushes);
			Undo_End();
			break;
		case ID_BRUSH_5SIDED:
			Undo_Start("5 Sided");
			Undo_AddBrushList(&g_brSelectedBrushes);
			Brush_MakeSided(5);
			Undo_EndBrushList(&g_brSelectedBrushes);
			Undo_End();
			break;
		case ID_BRUSH_6SIDED:
			Undo_Start("6 Sided");
			Undo_AddBrushList(&g_brSelectedBrushes);
			Brush_MakeSided(6);
			Undo_EndBrushList(&g_brSelectedBrushes);
			Undo_End();
			break;
		case ID_BRUSH_7SIDED:
			Undo_Start("7 Sided");
			Undo_AddBrushList(&g_brSelectedBrushes);
			Brush_MakeSided(7);
			Undo_EndBrushList(&g_brSelectedBrushes);
			Undo_End();
			break;
		case ID_BRUSH_8SIDED:
			Undo_Start("8 Sided");
			Undo_AddBrushList(&g_brSelectedBrushes);
			Brush_MakeSided(8);
			Undo_EndBrushList(&g_brSelectedBrushes);
			Undo_End();
			break;
		case ID_BRUSH_9SIDED:
			Undo_Start("9 Sided");
			Undo_AddBrushList(&g_brSelectedBrushes);
			Brush_MakeSided(9);
			Undo_EndBrushList(&g_brSelectedBrushes);
			Undo_End();
			break;

// sikk---> Brush Primitives
		case ID_BRUSH_CYLINDER:
			Undo_Start("Make Cylinder");
			Undo_AddBrushList(&g_brSelectedBrushes);
			DoSides(0);
			Undo_EndBrushList(&g_brSelectedBrushes);
			Undo_End();
			break;
		case ID_BRUSH_CONE:
			Undo_Start("Make Cone");
			Undo_AddBrushList(&g_brSelectedBrushes);
			DoSides(1);
			Undo_EndBrushList(&g_brSelectedBrushes);
			Undo_End();
			break;
		case ID_BRUSH_SPHERE:
			Undo_Start("Make Sphere");
			Undo_AddBrushList(&g_brSelectedBrushes);
			DoSides(2);
			Undo_EndBrushList(&g_brSelectedBrushes);
			Undo_End();
			break;
//		case ID_BRUSH_TORUS:
//			Undo_Start("Make Torus");
//			Undo_AddBrushList(&g_brSelectedBrushes);
//			DoSides(3);
//			Undo_EndBrushList(&g_brSelectedBrushes);
//			Undo_End();
//			break;
// <---sikk

//===================================
// help menu
//===================================
		case ID_HELP_HELP:
			// sikk - TODO: Compile a manual for QE3 and change link
			ShellExecute(NULL, "open", "docs\\QuakeEd3.chm", NULL, NULL, 1);
			break;

		case ID_HELP_KEYLIST:
			DoKeylist();
			break;

		case ID_HELP_ABOUT:
			DoAbout();
			break;

		default:
			return FALSE;
	}

	// sikk - Update Menu & Toolbar so state chages take effect
	QE_UpdateCommandUI();

	return TRUE;
}

/*
============
WMain_WndProc
============
*/
LONG WINAPI WMain_WndProc (
	HWND	hWnd,	// handle to window
	UINT	uMsg,	// message
	WPARAM	wParam,	// first message parameter
	LPARAM	lParam 	// second message parameter
	)
{
	RECT	rect;
	HDC		maindc;
	LPTOOLTIPTEXT	lpToolTipText;
	char	szToolTip[128];
    time_t	lTime;

	GetClientRect(hWnd, &rect);

	switch (uMsg)
	{
	case WM_TIMER:
		QE_CountBrushesAndUpdateStatusBar();
		QE_CheckAutoSave();
		return 0;

	case WM_DESTROY:
		SaveMruInReg(g_qeglobals.d_lpMruMenu, "Software\\id\\QuakeEd3\\MRU");
		DeleteMruMenu(g_qeglobals.d_lpMruMenu);
		PostQuitMessage(0);
		KillTimer(hWnd, QE_TIMER0);
		return 0;

	case WM_CREATE:
		maindc = GetDC(hWnd);
//		QEW_SetupPixelFormat(maindc, false);
		g_qeglobals.d_lpMruMenu = CreateMruMenuDefault();
		LoadMruInReg(g_qeglobals.d_lpMruMenu, "Software\\id\\QuakeEd3\\MRU");
	
		// Refresh the File menu.
		PlaceMenuMRUItem(g_qeglobals.d_lpMruMenu, GetSubMenu(GetMenu(hWnd), 0), ID_FILE_EXIT);
		return 0;

	case WM_SIZE:
		// resize the status window
		MoveWindow(g_qeglobals.d_hwndStatus, -100, 100, 10, 10, true);
		return 0;

	case WM_KEYDOWN:
		return QE_KeyDown(wParam);

   	case WM_CLOSE:
		/* call destroy window to cleanup and go away */
		if (!ConfirmModified())
			return TRUE;

		SaveWindowState(g_qeglobals.d_hwndXY, "XYWindow");
		SaveWindowState(g_qeglobals.d_hwndCamera, "CameraWindow");
		SaveWindowState(g_qeglobals.d_hwndZ, "ZWindow");
		SaveWindowState(g_qeglobals.d_hwndEntity, "EntityWindow");
		SaveWindowState(g_qeglobals.d_hwndMain, "MainWindow");

		// FIXME: is this right?
		strcpy(g_qeglobals.d_savedinfo.szLastMap, g_szCurrentMap); // sikk - save current map name for Load Last Map option
		SaveRegistryInfo("SavedInfo", &g_qeglobals.d_savedinfo, sizeof(g_qeglobals.d_savedinfo));

		time(&lTime);	// sikk - Print current time for logging purposes
		Sys_Printf("\nSession Stopped: %s", ctime(&lTime));

		DestroyWindow(hWnd);
		return 0;

	case WM_COMMAND:
		return CommandHandler(hWnd, wParam, lParam);

	case WM_INITMENUPOPUP :
		QE_UpdateCommandUI();	// sikk - Update Menu & Toolbar Items
		return 0;	
	
	case WM_NOTIFY:
		switch (((LPNMHDR)lParam)->code) 
		{
// sikk---> Tooltip 
		case TTN_NEEDTEXT:
			// Display tool tip text.
			lpToolTipText = (LPTOOLTIPTEXT)lParam;
			LoadString(g_qeglobals.d_hInstance, 
					   lpToolTipText->hdr.idFrom,	// string ID == cmd ID
					   szToolTip,
					   sizeof(szToolTip));
			lpToolTipText->lpszText = szToolTip;
			break;
// <---sikk

		case RBN_BEGINDRAG:	// sikk - Rebar (to handle movement)
			break;
		case RBN_ENDDRAG:	// sikk - Rebar (to handle movement)
			break;

		case TBN_HOTITEMCHANGE:	// sikk - For Toolbar Button Highlighting
			break;

		default:
			return TRUE;
			break;
		}
		return 0;
	}
	return DefWindowProc(hWnd, uMsg, wParam, lParam);
}

/*
==============
WMain_Create
==============
*/
void WMain_Create (HINSTANCE hInstance)
{
	WNDCLASS	wc;
	int			i;
	HMENU		hMenu;
	
	/* Register the main class */
	memset(&wc, 0, sizeof(wc));

	wc.style		 = 0;
	wc.lpfnWndProc	 = (WNDPROC)WMain_WndProc;
	wc.cbClsExtra	 = 0;
	wc.cbWndExtra	 = 0;
	wc.hInstance	 = hInstance;
	wc.hIcon		 = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON1));	// sikk - MainFrame Icon (pretty)
	wc.hCursor		 = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = (HBRUSH)(COLOR_APPWORKSPACE + 1);
	wc.lpszMenuName  = MAKEINTRESOURCE(IDR_MENU1);
	wc.lpszClassName = MAIN_WINDOW_CLASS;

	if (!RegisterClass(&wc))
		Error("Main_Register: Failed.");

	g_qeglobals.d_hwndMain = CreateWindow(MAIN_WINDOW_CLASS,		// registered class name
		"QuakeEd 3",												// window name
		QE3_MAIN_STYLE,												// window style
		0, 0,														// position of window
		g_nScreenWidth, g_nScreenHeight + GetSystemMetrics(SM_CYSIZE),	// window size
		0,															// parent or owner window
		0,															// menu or child-window identifier
		hInstance,													// application instance
		NULL);														// window-creation data

	if (!g_qeglobals.d_hwndMain)
		Error("Could not create Main Window.");

	// create a timer so that we can count brushes
	SetTimer(g_qeglobals.d_hwndMain, QE_TIMER0, 1000, NULL);
	
	LoadWindowState(g_qeglobals.d_hwndMain, "MainWindow");

	g_qeglobals.d_hwndRebar		= CreateReBar(g_qeglobals.d_hwndMain, hInstance);
	g_qeglobals.d_hwndToolbar1	= CreateToolBar(g_qeglobals.d_hwndRebar, hInstance, 0, 0, 6, 124);
	g_qeglobals.d_hwndToolbar2	= CreateToolBar(g_qeglobals.d_hwndRebar, hInstance, 1, 6, 6, 124);
	g_qeglobals.d_hwndToolbar3	= CreateToolBar(g_qeglobals.d_hwndRebar, hInstance, 2, 12, 6, 140);
	g_qeglobals.d_hwndToolbar4	= CreateToolBar(g_qeglobals.d_hwndRebar, hInstance, 3, 18, 4, 94);
	g_qeglobals.d_hwndToolbar5	= CreateToolBar(g_qeglobals.d_hwndRebar, hInstance, 4, 22, 3, 70);
	g_qeglobals.d_hwndToolbar6	= CreateToolBar(g_qeglobals.d_hwndRebar, hInstance, 5, 25, 7, 148);
	g_qeglobals.d_hwndToolbar7	= CreateToolBar(g_qeglobals.d_hwndRebar, hInstance, 6, 32, 9, 178);
	g_qeglobals.d_hwndToolbar8	= CreateToolBar(g_qeglobals.d_hwndRebar, hInstance, 7, 41, 1, 24);
	g_qeglobals.d_hwndStatus	= CreateStatusBar(g_qeglobals.d_hwndMain);

	//
	// load misc info from registry
	//
	i = sizeof(g_qeglobals.d_savedinfo);
	LoadRegistryInfo("SavedInfo", &g_qeglobals.d_savedinfo, &i);
	
	if (g_qeglobals.d_savedinfo.nSize != sizeof(g_qeglobals.d_savedinfo))
	{
		// fill in new defaults
		g_qeglobals.d_savedinfo.nSize				= sizeof(g_qeglobals.d_savedinfo);
		g_qeglobals.d_savedinfo.nTexMenu			= ID_TEXTURES_TRILINEAR;

		g_qeglobals.d_savedinfo.nExclude			= 0;
		g_qeglobals.d_savedinfo.bShow_Axis			= true;		// sikk - Show Axis
		g_qeglobals.d_savedinfo.bShow_Blocks		= false;
		g_qeglobals.d_savedinfo.bShow_CameraGrid	= true;		// sikk - Show Camera Grid
		g_qeglobals.d_savedinfo.bShow_Coordinates	= true;
		g_qeglobals.d_savedinfo.bShow_LightRadius	= false;	// sikk - Show Light Radius
		g_qeglobals.d_savedinfo.bShow_MapBoundry	= true;		// sikk - Show Map Boundry Box
		g_qeglobals.d_savedinfo.bShow_Names			= true;
		g_qeglobals.d_savedinfo.bShow_SizeInfo		= true;
		g_qeglobals.d_savedinfo.bShow_Viewname		= true;		// sikk - Show View Name
		g_qeglobals.d_savedinfo.bShow_Workzone		= false;
		g_qeglobals.d_savedinfo.bNoClamp			= false;
		g_qeglobals.d_savedinfo.bScaleLockX			= false;
		g_qeglobals.d_savedinfo.bScaleLockY			= false;
		g_qeglobals.d_savedinfo.bScaleLockZ			= false;
		g_qeglobals.d_savedinfo.bCubicClip			= false;	// sikk - Cubic Clipping
		g_qeglobals.d_savedinfo.nCubicScale			= 32;		// sikk - Cubic Clipping
		g_qeglobals.d_savedinfo.nCameraSpeed		= 1024;		// sikk - Camera Speed Trackbar
// sikk---> Preferences Dialog
		g_qeglobals.d_savedinfo.bAutosave			= true;
		g_qeglobals.d_savedinfo.bRadiantLights		= true;
		g_qeglobals.d_savedinfo.bVertexSplitsFace	= true;
		g_qeglobals.d_savedinfo.nAutosave			= 5;
		g_qeglobals.d_savedinfo.nMapSize			= 8192;
		g_qeglobals.d_savedinfo.nUndoLevels			= 32;
		g_qeglobals.d_savedinfo.fGamma				= 1.0;
		strcpy(g_qeglobals.d_savedinfo.szHeapsize, "16384");
		strcpy(g_qeglobals.d_savedinfo.szSkill, "1");
// <---sikk
		for (i = 0; i < 3; i++)
		{
			g_qeglobals.d_savedinfo.v3Colors[COLOR_BRUSHES][i]		= 0.0f;
			g_qeglobals.d_savedinfo.v3Colors[COLOR_CAMERABACK][i]	= 0.25f;
			g_qeglobals.d_savedinfo.v3Colors[COLOR_CAMERAGRID][i]	= 0.2f;
			g_qeglobals.d_savedinfo.v3Colors[COLOR_GRIDBACK][i]		= 1.0f;
			g_qeglobals.d_savedinfo.v3Colors[COLOR_GRIDMAJOR][i]	= 0.5f;
			g_qeglobals.d_savedinfo.v3Colors[COLOR_GRIDMINOR][i]	= 0.75f;
			g_qeglobals.d_savedinfo.v3Colors[COLOR_GRIDTEXT][i]		= 0.0f;
			g_qeglobals.d_savedinfo.v3Colors[COLOR_MAPBOUNDRY][i]	= 0.0f;
			g_qeglobals.d_savedinfo.v3Colors[COLOR_TEXTUREBACK][i]	= 0.25f;
			g_qeglobals.d_savedinfo.v3Colors[COLOR_TEXTURETEXT][i]	= 0.0f;
		}

		g_qeglobals.d_savedinfo.v3Colors[COLOR_CLIPPER][0]		= 0.0f;
		g_qeglobals.d_savedinfo.v3Colors[COLOR_CLIPPER][1]		= 0.0f;
		g_qeglobals.d_savedinfo.v3Colors[COLOR_CLIPPER][2]		= 1.0f;

		g_qeglobals.d_savedinfo.v3Colors[COLOR_GRIDBLOCK][0]	= 0.0f;
		g_qeglobals.d_savedinfo.v3Colors[COLOR_GRIDBLOCK][1]	= 0.0f;
		g_qeglobals.d_savedinfo.v3Colors[COLOR_GRIDBLOCK][2]	= 1.0f;

		g_qeglobals.d_savedinfo.v3Colors[COLOR_SELBRUSHES][0]	= 1.0f;
		g_qeglobals.d_savedinfo.v3Colors[COLOR_SELBRUSHES][1]	= 0.0f;
		g_qeglobals.d_savedinfo.v3Colors[COLOR_SELBRUSHES][2]	= 0.0f;

		g_qeglobals.d_savedinfo.v3Colors[COLOR_VIEWNAME][0]		= 0.5f;
		g_qeglobals.d_savedinfo.v3Colors[COLOR_VIEWNAME][1]		= 0.0f;
		g_qeglobals.d_savedinfo.v3Colors[COLOR_VIEWNAME][2]		= 0.75f;

		Sys_UpdateWindows(W_ALL);
	}

	if ((hMenu = GetMenu(g_qeglobals.d_hwndMain)) != 0)
	{
		/*
		** by default all of these are checked because that's how they're defined in the menu editor
		*/
		if (!g_qeglobals.d_savedinfo.bShow_Axis)	// sikk - Show Axis
			CheckMenuItem(hMenu, ID_VIEW_SHOWAXIS, MF_UNCHECKED);
		if (g_qeglobals.d_savedinfo.bShow_Blocks)	// sikk - Show Blocks moved to savedinfo_t
			CheckMenuItem(hMenu, ID_VIEW_SHOWBLOCKS, MF_CHECKED);
		if (!g_qeglobals.d_savedinfo.bShow_CameraGrid)	// sikk - Show Camera Grid
			CheckMenuItem(hMenu, ID_VIEW_SHOWCAMERAGRID, MF_UNCHECKED);
		if (!g_qeglobals.d_savedinfo.bShow_Coordinates)
			CheckMenuItem(hMenu, ID_VIEW_SHOWCOORDINATES, MF_UNCHECKED);
		if (g_qeglobals.d_savedinfo.bShow_LightRadius)	// sikk - Show Light Radius
			CheckMenuItem(hMenu, ID_VIEW_SHOWLIGHTRADIUS, MF_CHECKED);
		if (!g_qeglobals.d_savedinfo.bShow_MapBoundry)	// sikk - Show Map Boundry
			CheckMenuItem(hMenu, ID_VIEW_SHOWMAPBOUNDRY, MF_UNCHECKED);
		if (!g_qeglobals.d_savedinfo.bShow_Names)
			CheckMenuItem(hMenu, ID_VIEW_SHOWNAMES, MF_UNCHECKED);
		if (!g_qeglobals.d_savedinfo.bShow_SizeInfo)
			CheckMenuItem(hMenu, ID_VIEW_SHOWSIZEINFO, MF_UNCHECKED);
		if (!g_qeglobals.d_savedinfo.bShow_Viewname)
			CheckMenuItem(hMenu, ID_VIEW_SHOWVIEWNAME, MF_UNCHECKED);
		if (g_qeglobals.d_savedinfo.bShow_Workzone)	// sikk - Show Workzone moved to savedinfo_t
			CheckMenuItem(hMenu, ID_VIEW_SHOWWORKZONE, MF_CHECKED);

		if (g_qeglobals.d_savedinfo.nExclude & EXCLUDE_ANGLES)
			CheckMenuItem(hMenu, ID_VIEW_SHOWANGLES, MF_UNCHECKED);
		if (g_qeglobals.d_savedinfo.nExclude & EXCLUDE_LIGHTS)
			CheckMenuItem(hMenu, ID_VIEW_SHOWLIGHTS, MF_UNCHECKED);
		if (g_qeglobals.d_savedinfo.nExclude & EXCLUDE_ENT)
			CheckMenuItem(hMenu, ID_VIEW_ENTITY, MF_UNCHECKED);
		if (g_qeglobals.d_savedinfo.nExclude & EXCLUDE_PATHS)
			CheckMenuItem(hMenu, ID_VIEW_SHOWPATH, MF_UNCHECKED);
		if (g_qeglobals.d_savedinfo.nExclude & EXCLUDE_WATER)
			CheckMenuItem(hMenu, ID_VIEW_SHOWWATER, MF_UNCHECKED);
		if (g_qeglobals.d_savedinfo.nExclude & EXCLUDE_WORLD)
			CheckMenuItem(hMenu, ID_VIEW_SHOWWORLD, MF_UNCHECKED);
		if (g_qeglobals.d_savedinfo.nExclude & EXCLUDE_CLIP)
			CheckMenuItem(hMenu, ID_VIEW_SHOWCLIP, MF_UNCHECKED);
		if (g_qeglobals.d_savedinfo.bNoClamp)
			CheckMenuItem(hMenu, ID_GRID_SNAPTOGRID, MF_UNCHECKED);

		if (g_qeglobals.d_savedinfo.bScaleLockX)
		{
			CheckMenuItem(hMenu, ID_SELECTION_SCALELOCKX, MF_CHECKED);
			SendMessage(g_qeglobals.d_hwndToolbar6, TB_CHECKBUTTON, (WPARAM)ID_SELECTION_SCALELOCKX, (g_qeglobals.d_savedinfo.bScaleLockX ? (LPARAM)true : (LPARAM)false));
		}
		if (g_qeglobals.d_savedinfo.bScaleLockY)
		{
			CheckMenuItem(hMenu, ID_SELECTION_SCALELOCKY, MF_CHECKED);
			SendMessage(g_qeglobals.d_hwndToolbar6, TB_CHECKBUTTON, (WPARAM)ID_SELECTION_SCALELOCKY, (g_qeglobals.d_savedinfo.bScaleLockY ? (LPARAM)true : (LPARAM)false));
		}
		if (g_qeglobals.d_savedinfo.bScaleLockZ)
		{
			CheckMenuItem(hMenu, ID_SELECTION_SCALELOCKZ, MF_CHECKED);
			SendMessage(g_qeglobals.d_hwndToolbar6, TB_CHECKBUTTON, (WPARAM)ID_SELECTION_SCALELOCKZ, (g_qeglobals.d_savedinfo.bScaleLockZ ? (LPARAM)true : (LPARAM)false));
		}

		if (g_qeglobals.d_savedinfo.bCubicClip)
		{
			CheckMenuItem(hMenu, ID_VIEW_CUBICCLIP, MF_CHECKED);
			SendMessage(g_qeglobals.d_hwndToolbar7, TB_CHECKBUTTON, (WPARAM)ID_VIEW_CUBICCLIP, (g_qeglobals.d_savedinfo.bCubicClip ? (LPARAM)true : (LPARAM)false));
		}
	}

	ShowWindow(g_qeglobals.d_hwndMain, SW_SHOWMAXIMIZED);	// sikk - changed from "SW_SHOWDEFAULT" (personal preference)
}


/*
=============================================================

	REGISTRY INFO

=============================================================
*/

/*
==============
SaveRegistryInfo
==============
*/
BOOL SaveRegistryInfo (const char *pszName, void *pvBuf, long lSize)
{
	LONG	lres;
	DWORD	dwDisp;
	HKEY	hKeyId;

// sikk---> Preferences: Reset Registry
	if (g_qeglobals.d_bResetRegistry)
	{
		RegDeleteKey(HKEY_CURRENT_USER, "Software\\id\\QuakeEd3\\MRU");
		RegDeleteKey(HKEY_CURRENT_USER, "Software\\id\\QuakeEd3");
		return FALSE;
	}
// <---sikk

	lres = RegCreateKeyEx(HKEY_CURRENT_USER, "Software\\id\\QuakeEd3", 0, NULL, 
			REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKeyId, &dwDisp);

	if (lres != ERROR_SUCCESS)
		return FALSE;


	lres = RegSetValueEx(hKeyId, pszName, 0, REG_BINARY, pvBuf, lSize);

	RegCloseKey(hKeyId);

	if (lres != ERROR_SUCCESS)
		return FALSE;

	return TRUE;
}

/*
==============
LoadRegistryInfo
==============
*/
BOOL LoadRegistryInfo (const char *pszName, void *pvBuf, long *plSize)
{
	HKEY	hKey;
	long	lres, lType, lSize;

	if (plSize == NULL)
		plSize = &lSize;

	lres = RegOpenKeyEx(HKEY_CURRENT_USER, "Software\\id\\QuakeEd3", 0, KEY_READ, &hKey);

	if (lres != ERROR_SUCCESS)
		return FALSE;

	lres = RegQueryValueEx(hKey, pszName, NULL, &lType, pvBuf, plSize);

	RegCloseKey(hKey);

	if (lres != ERROR_SUCCESS)
		return FALSE;

	return TRUE;
}

/*
==============
SaveWindowState
==============
*/
BOOL SaveWindowState (HWND hWnd, const char *pszName)
{
	RECT rc;
	
	GetWindowRect(hWnd, &rc);
	if (hWnd != g_qeglobals.d_hwndMain)
		MapWindowPoints(NULL, g_qeglobals.d_hwndMain, (POINT *)&rc, 2);
	return SaveRegistryInfo(pszName, &rc, sizeof(rc));
}

/*
==============
LoadWindowState
==============
*/
BOOL LoadWindowState (HWND hWnd, const char *pszName)
{
	RECT rc;
	LONG lSize = sizeof(rc);

	if (LoadRegistryInfo(pszName, &rc, &lSize))
	{
		if (rc.left < 0)
			rc.left = 0;
		if (rc.top < 0)
			rc.top = 0;
		if (rc.right < rc.left + 16)
			rc.right = rc.left + 16;
		if (rc.bottom < rc.top + 16)
			rc.bottom = rc.top + 16;

		MoveWindow(hWnd, rc.left, rc.top, rc.right - rc.left, rc.bottom - rc.top, FALSE);
		return TRUE;
	}

	return FALSE;
}


/*
===============================================================

	STATUS WINDOW

===============================================================
*/

/*
==============
Sys_UpdateBrushStatusBar
==============
*/
void Sys_UpdateBrushStatusBar ()
{
//	extern int	g_nNumBrushes, g_nNumEntities, g_nNumTextures;
	char		numbrushbuffer[128] = "";

	sprintf(numbrushbuffer, "Brushes: %d  Entities: %d  Textures: %d", g_nNumBrushes, 
																	   g_nNumEntities, 
																	   g_nNumTextures);
	Sys_Status(numbrushbuffer, 2);
}

/*
==============
Sys_UpdateGridStatusBar
==============
*/
void Sys_UpdateGridStatusBar ()
{
	char gridstatus[128] = "";

	sprintf(gridstatus, "Grid Size: %d Grid Snap: %s Clip Mode: %s Texture Lock: %s Cubic Clip: %d", 
			g_qeglobals.d_nGridSize, 
			g_qeglobals.d_savedinfo.bNoClamp ? "off" : "on", 
			g_qeglobals.d_bClipMode ? "on" : "off", 
			g_qeglobals.d_bTextureLock ? "on" : "off",
			g_qeglobals.d_savedinfo.nCubicScale);	// sikk - Cubic Clipping
	Sys_Status(gridstatus, 1);
}

/*
==============
Sys_Status
==============
*/
void Sys_Status (const char *psz, int part )
{
	SendMessage(g_qeglobals.d_hwndStatus, SB_SETTEXT, part, (LPARAM)psz);
}

/*
==============
CreateStatusBar
==============
*/
HWND CreateStatusBar (HWND hWnd)
{
	HWND hwndSB;
	int partsize[4] = { 192, 560, 800, -1 };	// EER //sikk - adjusted sizes

	hwndSB = CreateStatusWindow(
		QE3_STATUSBAR_STYLE,	// window styles
		"Ready", 				// text for first pane 
		hWnd, 					// parent window
		ID_STATUSBAR);			// window ID
			

	SendMessage(hwndSB, SB_SETPARTS, 4, (long)partsize); // EER

	return hwndSB;
}

/*
===============================================================

	TOOLBAR

===============================================================
*/

#define NUMBUTTONS 42

/*
==============
CreateReBar
==============
*/
HWND CreateReBar (HWND hWnd, HINSTANCE hInst)
{
	HWND		hwndRB;
	REBARINFO	rbi;
	INITCOMMONCONTROLSEX icex;

	icex.dwSize = sizeof(INITCOMMONCONTROLSEX);
	icex.dwICC	= ICC_COOL_CLASSES | ICC_BAR_CLASSES;
	InitCommonControlsEx(&icex);

	hwndRB = CreateWindowEx(
		WS_EX_TOOLWINDOW,	// extended window style
		REBARCLASSNAME,		// registered class name
		NULL,				// window name
		QE3_REBAR_STYLE,	// window style
		0, 0, 0, 0,			// window position and size
		hWnd,				// parent or owner window
		(HMENU)ID_REBAR,	// menu or child-window identifier
		hInst,				// application instance
		NULL);				// window-creation data

	if(!hwndRB)
		return NULL;

	// Initialize and send the REBARINFO structure.
	rbi.cbSize	= sizeof(REBARINFO);	// Required when using this struct.
	rbi.fMask	= 0;
	rbi.himl	= (HIMAGELIST)NULL;
	if(!SendMessage(hwndRB, RB_SETBARINFO, 0, (LPARAM)&rbi))
		return NULL;

	return (hwndRB);
}

/*
==============
CreateToolBar
==============
*/
HWND CreateToolBar (HWND hWnd, HINSTANCE hInst, int nIndex, int nPos, int nButtons, int nSize)
{ 
	HWND			hwndTB; 
	TBBUTTON		tbb[NUMBUTTONS];
	REBARBANDINFO	rbBand;
	DWORD			dwBtnSize;

	// Ensure that the common control DLL is loaded. 
	InitCommonControls(); 

	// Fill the TBBUTTON array with button information, 
	// and add the buttons to the toolbar.
	tbb[0].iBitmap		= 0;
	tbb[0].idCommand	= ID_FILE_NEW;
	tbb[0].fsState		= TBSTATE_ENABLED;
	tbb[0].fsStyle		= TBSTYLE_BUTTON;
	tbb[0].dwData		= 0;
	tbb[0].iString		= 0;

	tbb[1].iBitmap		= 1;
	tbb[1].idCommand	= ID_FILE_OPEN;
	tbb[1].fsState		= TBSTATE_ENABLED;
	tbb[1].fsStyle		= TBSTYLE_BUTTON;
	tbb[1].dwData		= 0;
	tbb[1].iString		= 0;

	tbb[2].iBitmap		= 2;
	tbb[2].idCommand	= ID_FILE_SAVE;
	tbb[2].fsState		= TBSTATE_ENABLED;
	tbb[2].fsStyle		= TBSTYLE_BUTTON;
	tbb[2].dwData		= 0;
	tbb[2].iString		= 0;

	tbb[3].iBitmap		= 0;
	tbb[3].idCommand	= 0;
	tbb[3].fsState		= TBSTATE_ENABLED;
	tbb[3].fsStyle		= TBSTYLE_SEP;
	tbb[3].dwData		= 0;
	tbb[3].iString		= 0;

	tbb[4].iBitmap		= 3;
	tbb[4].idCommand	= ID_FILE_PRINTXY;
	tbb[4].fsState		= TBSTATE_ENABLED;
	tbb[4].fsStyle		= TBSTYLE_BUTTON;
	tbb[4].dwData		= 0;
	tbb[4].iString		= 0;

	tbb[5].iBitmap		= 4;
	tbb[5].idCommand	= ID_HELP_ABOUT;
	tbb[5].fsState		= TBSTATE_ENABLED;
	tbb[5].fsStyle		= TBSTYLE_BUTTON;
	tbb[5].dwData		= 0;
	tbb[5].iString		= 0;

	tbb[6].iBitmap		= 5;
	tbb[6].idCommand	= ID_SELECTION_CLONE;
	tbb[6].fsState		= TBSTATE_ENABLED;
	tbb[6].fsStyle		= TBSTYLE_BUTTON;
	tbb[6].dwData		= 0;
	tbb[6].iString		= 0;

	tbb[7].iBitmap		= 6;
	tbb[7].idCommand	= ID_SELECTION_INVERT;
	tbb[7].fsState		= TBSTATE_ENABLED;
	tbb[7].fsStyle		= TBSTYLE_BUTTON;
	tbb[7].dwData		= 0;
	tbb[7].iString		= 0;

	tbb[8].iBitmap		= 7;
	tbb[8].idCommand	= ID_SELECTION_DELETE;
	tbb[8].fsState		= TBSTATE_ENABLED;
	tbb[8].fsStyle		= TBSTYLE_BUTTON;
	tbb[8].dwData		= 0;
	tbb[8].iString		= 0;

	tbb[9].iBitmap		= 0;
	tbb[9].idCommand	= 0;
	tbb[9].fsState		= TBSTATE_ENABLED;
	tbb[9].fsStyle		= TBSTYLE_SEP;
	tbb[9].dwData		= 0;
	tbb[9].iString		= 0;

	tbb[10].iBitmap		= 8;
	tbb[10].idCommand	= ID_EDIT_UNDO;
	tbb[10].fsState		= TBSTATE_ENABLED;
	tbb[10].fsStyle		= TBSTYLE_BUTTON;
	tbb[10].dwData		= 0;
	tbb[10].iString		= 0;

	tbb[11].iBitmap		= 9;
	tbb[11].idCommand	= ID_EDIT_REDO;
	tbb[11].fsState		= TBSTATE_ENABLED;
	tbb[11].fsStyle		= TBSTYLE_BUTTON;
	tbb[11].dwData		= 0;
	tbb[11].iString		= 0;

	tbb[12].iBitmap		= 10;
	tbb[12].idCommand	= ID_SELECTION_FLIPX;
	tbb[12].fsState		= TBSTATE_ENABLED;
	tbb[12].fsStyle		= TBSTYLE_BUTTON;
	tbb[12].dwData		= 0;
	tbb[12].iString		= 0;

	tbb[13].iBitmap		= 11;
	tbb[13].idCommand	= ID_SELECTION_ROTATEX;
	tbb[13].fsState		= TBSTATE_ENABLED;
	tbb[13].fsStyle		= TBSTYLE_BUTTON;
	tbb[13].dwData		= 0;
	tbb[13].iString		= 0;

	tbb[14].iBitmap		= 12;
	tbb[14].idCommand	= ID_SELECTION_FLIPY;
	tbb[14].fsState		= TBSTATE_ENABLED;
	tbb[14].fsStyle		= TBSTYLE_BUTTON;
	tbb[14].dwData		= 0;
	tbb[14].iString		= 0;

	tbb[15].iBitmap		= 13;
	tbb[15].idCommand	= ID_SELECTION_ROTATEY;
	tbb[15].fsState		= TBSTATE_ENABLED;
	tbb[15].fsStyle		= TBSTYLE_BUTTON;
	tbb[15].dwData		= 0;
	tbb[15].iString		= 0;

	tbb[16].iBitmap		= 14;
	tbb[16].idCommand	= ID_SELECTION_FLIPZ;
	tbb[16].fsState		= TBSTATE_ENABLED;
	tbb[16].fsStyle		= TBSTYLE_BUTTON;
	tbb[16].dwData		= 0;
	tbb[16].iString		= 0;

	tbb[17].iBitmap		= 15;
	tbb[17].idCommand	= ID_SELECTION_ROTATEZ;
	tbb[17].fsState		= TBSTATE_ENABLED;
	tbb[17].fsStyle		= TBSTYLE_BUTTON;
	tbb[17].dwData		= 0;
	tbb[17].iString		= 0;

	tbb[18].iBitmap		= 16;
	tbb[18].idCommand	= ID_SELECTION_SELECTCOMPLETETALL;
	tbb[18].fsState		= TBSTATE_ENABLED;
	tbb[18].fsStyle		= TBSTYLE_BUTTON;
	tbb[18].dwData		= 0;
	tbb[18].iString		= 0;

	tbb[19].iBitmap		= 17;
	tbb[19].idCommand	= ID_SELECTION_SELECTTOUCHING;
	tbb[19].fsState		= TBSTATE_ENABLED;
	tbb[19].fsStyle		= TBSTYLE_BUTTON;
	tbb[19].dwData		= 0;
	tbb[19].iString		= 0;

	tbb[20].iBitmap		= 18;
	tbb[20].idCommand	= ID_SELECTION_SELECTPARTIALTALL;
	tbb[20].fsState		= TBSTATE_ENABLED;
	tbb[20].fsStyle		= TBSTYLE_BUTTON;
	tbb[20].dwData		= 0;
	tbb[20].iString		= 0;

	tbb[21].iBitmap		= 19;
	tbb[21].idCommand	= ID_SELECTION_SELECTINSIDE;
	tbb[21].fsState		= TBSTATE_ENABLED;
	tbb[21].fsStyle		= TBSTYLE_BUTTON;
	tbb[21].dwData		= 0;
	tbb[21].iString		= 0;

	tbb[22].iBitmap		= 20;
	tbb[22].idCommand	= ID_SELECTION_CSGHOLLOW;
	tbb[22].fsState		= TBSTATE_ENABLED;
	tbb[22].fsStyle		= TBSTYLE_BUTTON;
	tbb[22].dwData		= 0;
	tbb[22].iString		= 0;

	tbb[23].iBitmap		= 21;
	tbb[23].idCommand	= ID_SELECTION_CSGSUBTRACT;
	tbb[23].fsState		= TBSTATE_ENABLED;
	tbb[23].fsStyle		= TBSTYLE_BUTTON;
	tbb[23].dwData		= 0;
	tbb[23].iString		= 0;

	tbb[24].iBitmap		= 22;
	tbb[24].idCommand	= ID_SELECTION_CSGMERGE;
	tbb[24].fsState		= TBSTATE_ENABLED;
	tbb[24].fsStyle		= TBSTYLE_BUTTON;
	tbb[24].dwData		= 0;
	tbb[24].iString		= 0;

	tbb[25].iBitmap		= 23;
	tbb[25].idCommand	= ID_SELECTION_CLIPPER;
	tbb[25].fsState		= TBSTATE_ENABLED;
	tbb[25].fsStyle		= TBSTYLE_CHECK;
	tbb[25].dwData		= 0;
	tbb[25].iString		= 0;

	tbb[26].iBitmap		= 24;
	tbb[26].idCommand	= ID_SELECTION_DRAGEDGES;
	tbb[26].fsState		= TBSTATE_ENABLED;
	tbb[26].fsStyle		= TBSTYLE_CHECK;
	tbb[26].dwData		= 0;
	tbb[26].iString		= 0;

	tbb[27].iBitmap		= 25;
	tbb[27].idCommand	= ID_SELECTION_DRAGVERTICES;
	tbb[27].fsState		= TBSTATE_ENABLED;
	tbb[27].fsStyle		= TBSTYLE_CHECK;
	tbb[27].dwData		= 0;
	tbb[27].iString		= 0;

	tbb[28].iBitmap		= 0;
	tbb[28].idCommand	= 0;
	tbb[28].fsState		= TBSTATE_ENABLED;
	tbb[28].fsStyle		= TBSTYLE_SEP;
	tbb[28].dwData		= 0;
	tbb[28].iString		= 0;

	tbb[29].iBitmap		= 26;
	tbb[29].idCommand	= ID_SELECTION_SCALELOCKX;
	tbb[29].fsState		= TBSTATE_ENABLED;
	tbb[29].fsStyle		= TBSTYLE_CHECK;
	tbb[29].dwData		= 0;
	tbb[29].iString		= 0;

	tbb[30].iBitmap		= 27;
	tbb[30].idCommand	= ID_SELECTION_SCALELOCKY;
	tbb[30].fsState		= TBSTATE_ENABLED;
	tbb[30].fsStyle		= TBSTYLE_CHECK;
	tbb[30].dwData		= 0;
	tbb[30].iString		= 0;

	tbb[31].iBitmap		= 28;
	tbb[31].idCommand	= ID_SELECTION_SCALELOCKZ;
	tbb[31].fsState		= TBSTATE_ENABLED;
	tbb[31].fsStyle		= TBSTYLE_CHECK;
	tbb[31].dwData		= 0;
	tbb[31].iString		= 0;

	tbb[32].iBitmap		= 29;
	tbb[32].idCommand	= ID_VIEW_NEXTVIEW;
	tbb[32].fsState		= TBSTATE_ENABLED;
	tbb[32].fsStyle		= TBSTYLE_BUTTON;
	tbb[32].dwData		= 0;
	tbb[32].iString		= 0;

	tbb[33].iBitmap		= 30;
	tbb[33].idCommand	= ID_VIEW_CENTERONSELECTION;
	tbb[33].fsState		= TBSTATE_ENABLED;
	tbb[33].fsStyle		= TBSTYLE_BUTTON;
	tbb[33].dwData		= 0;
	tbb[33].iString		= 0;

	tbb[34].iBitmap		= 0;
	tbb[34].idCommand	= 0;
	tbb[34].fsState		= TBSTATE_ENABLED;
	tbb[34].fsStyle		= TBSTYLE_SEP;
	tbb[34].dwData		= 0;
	tbb[34].iString		= 0;

	tbb[35].iBitmap		= 31;
	tbb[35].idCommand	= ID_TEXTURES_POPUP;
	tbb[35].fsState		= TBSTATE_ENABLED;
	tbb[35].fsStyle		= TBSTYLE_BUTTON;
	tbb[35].dwData		= 0;
	tbb[35].iString		= 0;

	tbb[36].iBitmap		= 0;
	tbb[36].idCommand	= 0;
	tbb[36].fsState		= TBSTATE_ENABLED;
	tbb[36].fsStyle		= TBSTYLE_SEP;
	tbb[36].dwData		= 0;
	tbb[36].iString		= 0;

	tbb[37].iBitmap		= 32;
	tbb[37].idCommand	= ID_VIEW_CAMSPEED;
	tbb[37].fsState		= TBSTATE_ENABLED;
	tbb[37].fsStyle		= TBSTYLE_BUTTON;
	tbb[37].dwData		= 0;
	tbb[37].iString		= 0;

	tbb[38].iBitmap		= 33;
	tbb[38].idCommand	= ID_VIEW_CUBICCLIP;
	tbb[38].fsState		= TBSTATE_ENABLED;
	tbb[38].fsStyle		= TBSTYLE_CHECK;
	tbb[38].dwData		= 0;
	tbb[38].iString		= 0;

	tbb[39].iBitmap		= 34;
	tbb[39].idCommand	= ID_VIEW_CUBICCLIPZOOMOUT;
	tbb[39].fsState		= TBSTATE_ENABLED;
	tbb[39].fsStyle		= TBSTYLE_BUTTON;
	tbb[39].dwData		= 0;
	tbb[39].iString		= 0;

	tbb[40].iBitmap		= 35;
	tbb[40].idCommand	= ID_VIEW_CUBICCLIPZOOMIN;
	tbb[40].fsState		= TBSTATE_ENABLED;
	tbb[40].fsStyle		= TBSTYLE_BUTTON;
	tbb[40].dwData		= 0;
	tbb[40].iString		= 0;

	tbb[41].iBitmap		= 36;
	tbb[41].idCommand	= ID_MISC_TESTMAP;
	tbb[41].fsState		= TBSTATE_ENABLED;
	tbb[41].fsStyle		= TBSTYLE_BUTTON;
	tbb[41].dwData		= 0;
	tbb[41].iString		= 0;

	
	hwndTB = CreateToolbarEx(hWnd,	// Handle to the parent window 
		QE3_TOOLBAR_STYLE,			// Styles
		ID_TOOLBAR,					// Control identifier
		nButtons,					// Number of button images 
		(HINSTANCE)hInst,			// Module instance 
		IDR_TOOLBAR1,				// Resource identifier for the bitmap resource
		(LPCTBBUTTON)&tbb[nPos],	// Address of an array of TBBUTTON 
		nButtons,					// Number of buttons to add to toolbar
		0, 0,						// width & height of buttons
		0, 0,						// width & height of bitmaps
		sizeof(TBBUTTON));			// Size of a TBBUTTON structure

	// Get the height of the toolbar buttons.
	dwBtnSize = SendMessage(hwndTB, TB_GETBUTTONSIZE, 0, 0);

	// Initialize REBARBANDINFO for all coolbar bands.
	rbBand.cbSize = sizeof(REBARBANDINFO);
	rbBand.fMask  = RBBIM_STYLE |		// fStyle is valid
					RBBIM_CHILD |		// hwndChild is valid
					RBBIM_CHILDSIZE |	// cxMinChild and cyMinChild are valid
					RBBIM_SIZE |		// cx is valid
					RBBIM_IDEALSIZE |	// cxIdeal is valid
					RBBIM_ID;			// wID is valid
	rbBand.fStyle		= RBBS_CHILDEDGE | RBBS_GRIPPERALWAYS;
	rbBand.hwndChild	= hwndTB;
	rbBand.cxMinChild	= nSize;
	rbBand.cyMinChild	= HIWORD(dwBtnSize);
	rbBand.cx			= nSize;
	rbBand.cxIdeal		= nSize;
	rbBand.wID			= ID_TOOLBAR + nIndex;

	// Insert band into rebar.
	SendMessage(hWnd, RB_INSERTBAND, (WPARAM)nIndex, (LPARAM)(LPREBARBANDINFO)&rbBand);

	return hwndTB; 
}

/*
==============
CreateTrackBar
==============
*//*
HWND CreateTrackBar (HWND hWnd, HINSTANCE hInst, int nIndex)
{ 
	HWND			hwndTrack;
	REBARINFO		rbi;
	REBARBANDINFO	rbBand;
	HIMAGELIST		hIml;
	HBITMAP			hBitmap, hMask;

	// Load bitmap for Trackbar Icon and add to ImageList
	hIml	= ImageList_Create(24, 16, ILC_COLORDDB | ILC_MASK, 1, 0);
	hBitmap	= LoadBitmap(hInst, MAKEINTRESOURCE(IDB_CAMSPEED));
	hMask	= LoadBitmap(hInst, MAKEINTRESOURCE(IDB_CAMSPEEDMASK));
	ImageList_Add(hIml, hBitmap, hMask);

	//set up the ReBar
	rbi.fMask	= RBIM_IMAGELIST;
	rbi.cbSize	= sizeof(rbi);
	rbi.himl	= hIml;
	SendMessage(g_qeglobals.d_hwndRebar, RB_SETBARINFO, 0, (LPARAM)&rbi);

	hwndTrack = CreateWindowEx(0,	// extended window style
		TRACKBAR_CLASS,				// registered class name
		"Trackbar Control",			// window name
		QE3_TRACKBAR_STYLE,			// window style
		0, 0,						// window position
		0, 0,						// window size
		hWnd,						// parent or owner window
		(HMENU)ID_TRACKBAR,			// menu or child-window identifier
		hInst,						// application instance
		NULL						// window-creation data
		); 

	// Sets the range of minimum and maximum logical positions for the slider in the trackbar
	// WPARAM: redraw flag	LPARAM: min & max positions
	SendMessage(hwndTrack, TBM_SETRANGE, (WPARAM)TRUE, (LPARAM)MAKELONG(0, 4096));
	// Sets the interval frequency for tick marks in a trackbar
	// WPARAM: frequency 
	SendMessage(hwndTrack, TBM_SETTICFREQ, (WPARAM)1024, (LPARAM)0);
	// Sets the number of logical positions the trackbar's slider moves with arrow keys
	// LPARAM: new line size
	SendMessage(hwndTrack, TBM_SETLINESIZE, (WPARAM)0, (LPARAM)64);
	// Sets the number of logical positions the trackbar's slider moves with PgUp/PgDn keys
	// LPARAM: new page size
	SendMessage(hwndTrack, TBM_SETPAGESIZE, (WPARAM)0, (LPARAM)256);
	//Sets the length of the slider in a trackbar.
	// WPARAM: Length 
	SendMessage(hwndTrack, TBM_SETTHUMBLENGTH, (WPARAM)12, (LPARAM)0);

	// Initialize REBARBANDINFO for rebar band.
	rbBand.cbSize		= sizeof(REBARBANDINFO);
	rbBand.fMask		= RBBIM_STYLE |		// fStyle is valid
						  RBBIM_IMAGE	|	// iImage is valid
						  RBBIM_CHILD |		// hwndChild is valid
						  RBBIM_CHILDSIZE |	// cxMinChild and cyMinChild are valid
						  RBBIM_SIZE |		// cx is valid
						  RBBIM_IDEALSIZE |	// cxIdeal is valid
						  RBBIM_ID;			// wID is valid
	rbBand.fStyle		= RBBS_CHILDEDGE | RBBS_GRIPPERALWAYS;
	rbBand.iImage		= 0;
	rbBand.hwndChild	= hwndTrack;
	rbBand.cxMinChild	= 46;
	rbBand.cyMinChild	= 22;
	rbBand.cx			= 48;
	rbBand.cxIdeal		= 48;
	rbBand.wID			= ID_TRACKBAR;

	// Insert band into rebar.
	SendMessage(g_qeglobals.d_hwndRebar, RB_INSERTBAND, (WPARAM)nIndex, (LPARAM)(LPREBARBANDINFO)&rbBand);

	return hwndTrack;
}*/
